<?php
/*
 * vim: set tabstop=4 : 
 * vim: set number :
 *
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('base/Controller.php');
/**
 *
 * @author Barry Nauta March 2003
 * @package be.nauta.booby.base
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta 
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code> 
 * and look for licenses
 */
class AboutController extends Controller
{
	/**
	 * Default constructor.
	 */
	function AboutController ()
	{
		parent::Controller ();
		$this->title = 'Booby - About';
		$this->pluginName = 'about';
		$this->itemName = 'About';
	}
	
	/**
	 * Get the actions for the about page. Since this is 
	 * a static information page, no actions are defined
	 */
	function getActions ()
	{
	}
	
	/**
	 * Activates this page which in this case means retrieving
	 * the about information from the dictionary and passing
	 * it on as renderObject to the renderEngine
	 */
	function activate ()
	{
		$dictionary = $this->getDictionary ();
		$this->renderer = 'show'.$this->getItemName();
		$this->renderObjects= $dictionary['about_page'];
	}
	
	/**
	 * Display which basically means that the template will be invoked
	 */
	function displayObsolete ()
	{
		global $menuItems, $menu;

		$this->renderEngine->assign('title', $this->getTitle ());
		$this->renderEngine->assign('menuItems', $menuItems);
		$this->renderEngine->assign('menu', $menu);
		$this->renderEngine->assign('dictionary', 
			$this->getDictionary ());

		//$this->renderEngine->assign('itemId', $this->getItemId ());
		//$this->renderEngine->assign('parentId', $this->getParentId ());

		$this->renderEngine->assign('parameters', 
			$this->getParameters ());
		$this->renderEngine->assign('action', 
			$this->getAction ());
		$this->renderEngine->assign('renderObjects', 
			$this->getRenderObjects ());
		$this->renderEngine->assign('renderActions', 
			$this->getActions ());
		$this->renderEngine->assign ('renderer', $this->getTemplateFile ());

		if (isset ($_GET['debug']))
		{
			error_reporting(E_ALL);			
			$this->renderEngine->display
				('templates/'.$this->getTemplate().'/template.tpl.php');
			// todo add more
		}
		else
		{
			error_reporting(E_ERROR);
			@$this->renderEngine->display
				('templates/'.$this->getTemplate().'/template.tpl.php');
		}
	}

	/**
	 * Returns the filename that will be given to the template for 
	 * display
	 * @return string the filename of the template file to show.
	 */
	function getTemplateFile ()
	{
		// Allow the template to override a specific file. 
		// If this file exist (the file in the template directory), 
		// it will be loaded, otherwise the default (in the plugin 
		// directory) will be loaded
		$renderer = 'templates/'.$this->getTemplate ().'/'.
			$this->getRenderer (); 
		if (!(file_exists ($renderer)))
		{
			$renderer = 'base/view/'.$this->getRenderer ();
		}
		return $renderer;
	}

	/**
	 * Retrieves the dictionary file by first tryin the language 
	 * specific dictionary file, defaulting to the english version if 
	 * the language specific file for the item does not exist and 
	 * returns the contents as an array
	 *
	 * @return array the dictionary
	 */
	function getDictionary ()
	{
		include ('base/lang/dictionary_EN.php');
		if (file_exists ('base/lang/dictionary_'.
			$_SESSION['language'] . '.php'))
		{
			include ('base/lang/dictionary_'.
				$_SESSION['language'].'.php');
		}
		return $dictionary;  
	}
}

//$controller = new AboutController ();
//$controller -> activate ();
//$controller -> display ();
?>

