<?php
/**
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('base/ItemController.php');
require_once ('base/model/User.php');
require_once ('base/model/UserFactory.php');
require_once ('base/model/UserServices.php');

require_class ('RightsManagerImpl', 'base/RightsManagerImpl.php'); // added by Michael
require_class ('RequestCast', 'base/util/request/RequestCast.class.php'); // added by Michael
/**
 * The User Controller
 *
 * @author Barry Nauta February 2004
 * @package be.nauta.booby.base
 * @copyright
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code>
 * and look for licenses
 */
class UserController extends ItemController
{
	/**
	 * Constructor. 
	 * Makes sure that the appropriate operations are instantiated.
	 */
	function UserController ()
	{
		parent::ItemController ();
		$this->operations = new UserServices ();
		$this->itemFactory = new UserFactory ();
		
		$this->rightsManager = new RightsManagerImpl(); 

		$this->pluginName = 'user';
		$this->title = 'Booby - Users';
		$this->itemName = 'User';
	}

	/**
	 * Activate. Basically this means that the appropriate actions are executed and an optional result is returned
	 * to be processed/displayed
	 */
	function activate ()
	{
		switch ($this->getAction ())
		{
			case 'modifyUser':
				if ($this->getUserName () == 'test')
				{
					die ('not allowed for test user');
				}
				$user = $this->itemFactory->requestToUser ();
				$this->operations->modifyUser ($this->getUserName(), $user);
				Header ("Location: index.php");
				break;
			default:
				Header ("Location: index.php");
				break;
		}
	}
	
	/**
	 * Returns the filename that will be given to the template for display
	 * @return string the filename of the template file to show.
	 */
	function getTemplateFile ()
	{
		// Allow the template to override a specific file. If this file exist (the file in the
		// template directory), it will be loaded, otherwise the default (in the plugin directory)
		// will be loaded
		$renderer = 'templates/'.$this->getTemplate ().'/'.$this->getRenderer (); 
		if (!(file_exists ($renderer)))
		{
			$renderer = 'base/view/'.$this->getRenderer ();
		}
		return $renderer;
	}
	
	/**
	 * Retrieves the dictionary file by first tryin the language specific
	 * dictionary file, defaulting to the english version if the language specific file for
	 * the item does not exist and returns the contents as an array
	 * @return array the dictionary
	 */
	function getDictionary ()
	{
		include ('base/lang/dictionary_EN.php');
		if (file_exists ('base/lang/dictionary_'.$_SESSION['language'] . '.php'))
		{
			include ('base/lang/dictionary_'.$_SESSION['language'] . '.php');
		}
		return $dictionary;  
	}
	
	
}
//$controller = new UserController ();
//$controller -> activate ();
//$controller -> display ();
?>
