<?php
/*
 * vim: set tabstop=4 :
 * vim: set number : 
 *
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is release under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('base/util/databaseConnection.php');
/**
 * Operations on access control list functionality in Booby
 *
 * @author Barry Nauta June 2004
 * @package be.nauta.booby.base.model
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta 
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code> 
 * and look for licenses
 */
class ACLServices //extends Services
{
	/**
 	 * Default constructor
	 */
	function ACLServices ()
	{
		include ('base/sql/aclQueries.php');
		$this->queries = $queries;
	}

	/**
	 * Inserts the accessability of an item
	 * @param owner string the owner of the item
	 * @param itemId integer the id of the item
	 * @param itemType string the type of the item (i.e. bookmark)
	 * @param userId string the identifier of the user which we
	 * would like to grant certain rightes
	 * @param accessRight integer the accessRight we want to give 
	 * combination of 4 for read, 2 for update and 1 for delete)
	 */
	function insertAcl ($owner, $itemId, $itemType,
		$userId, $accessRight)
	{
        global $db;
		$query  = sprintf ($this->queries['insertAcl'],
			$owner, $itemId, $itemType, $userId, $accessRight); 
		$result = $db->Execute($query) 
			or die("InsertACL: " . $db->ErrorMsg() . " " . $query);
	}
	
	/**
	 * Modifies the accessability of an item
	 * @param owner string the owner of the item
	 * @param itemId integer the id of the item
	 * @param itemType string the type of the item (i.e. bookmark)
	 * @param userId string the identifier of the user which we
	 * would like to grant certain rightes
	 * @param accessRight integer the accessRight we want to give 
	 * combination of 4 for read, 2 for update and 1 for delete)
	 */
	function modifyAcl ($owner, $itemId, $itemType,
		$userId, $accessRight)
	{
        global $db;
		$query  = sprintf ($this->queries['modifyAcl'],
			$accessRight, $owner, $itemId, $itemType, $userId); 
		$result = $db->Execute($query) 
			or die("ModifyACL: " . $db->ErrorMsg() . " " . $query);
	}
	
	/**
	 * Delete 
	 */
	function deleteAcl ($owner, $itemId, $itemType, $userId)
	{
        global $db;
		$query  = sprintf ($this->queries['deleteAcl'],
			$value, $name); 
		$result = $db->Execute($query) 
			or die("InsertACL: " . $db->ErrorMsg() . " " . $query);
	}

	/**
	 * Get the accessRights
	 */
	function getAccessRight ($owner, $itemId, $itemType, $userId)
	{
        global $db;
		$query  = sprintf ($this->queries['getAccessRight'],
			$owner, $itemId, $itemType, $userId); 
		$result = $db->Execute($query) 
			or die("getACL: " . $db->ErrorMsg() . " " . $query);
	}
}
?>
