<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is release under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('base/model/ItemFactory.php');
require_once ('base/model/Information.php');
/**
 * InformationFactory
 *
 * @author Barry Nauta
 * @date January 2004
 * @package be.nauta.booby.plugins.genealogy.model
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta <br />
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code> 
 * and look for licenses
 */
class InformationFactory extends ItemFactory
{
		/**
		 * Default constructor
		 */
		function InformationFactory ()
		{
			parent::ItemFactory ();
		}
	
				
		/**
		 * Factory method: Returns a database result into an item
		 *
		 * @param object result the result retrieved from the database
		 * @return array the items constructed from the database resultset
		 */
		function resultsetToItems ($result)
		{
			$items = array ();
			while (!$result -> EOF)
			{
				$item = new Information 
				(
					$result->fields['itemId'],
					$result->fields['owner'],
					$result->fields['parentId'],
					$result->fields['isParent'], 
					$result->fields['name'],
					$result->fields['description'],
					$result->fields['visibility'],
					$result->fields['category'],
					$result->fields['when_created'],
					$result->fields['when_modified'],
					$result->fields['referingId'],
					$result->fields['referingType'],
					$result->fields['reliability'],
					$result->fields['complete'],
					$result->fields['informationURL'],
					$result->fields['imageURL'],
					$result->fields['comments']
				);
				$items [] = $item;
				$result->MoveNext ();
			}
			return $items;
		}
		
		/**
		 * Factory method. Return an HTTP request into an item by 
		 * fecthing the appropriate parameters from the POST request
		 *
		 * @return object the item constructed from the POST request
		 * @uses the POST request
		 */
		function requestToItem ()
		{
			$visibility = $this->getFromPost ('visibility', 'private');
			$parentId = $this->getFromPost ('parentId', 0);
			$isParent = $this->getFromPost ('isParent', 0);
			$when_created = $this->getFromPost ('when_created', null);
			$when_modified = $this->getFromPost ('when_modified', null);
			$itemId = $this->getFromPost ('itemId', 0);
			$category = $this->getFromPost ('category', null);
			$name = $this->getFromPost ('name', null);
			$description = $this->getFromPost ('description', null);

			$referingId = $this->getFromPost ('referingId', 0);
			$referingType = $this->getFromPost ('referingType', null);
			$imageURL = $this->getFromPost ('imageURL', null);
			$informationURL = $this->getFromPost ('informationURL', null);
			$complete = $this->getFromPost ('complete', null);
			$reliability = $this->getFromPost ('reliability', null);
			$comments = $this->getFromPost ('comments', null);
			
			$items = new Information 
			(
				$itemId,
				$_SESSION['boobyUsername'],
				$parentId,
				$isParent,
				$name,
				$description,
				$visibility,
				$category,
				$when_created,
				$when_modified,
				$referingId,
				$referingType,
				$reliability,
				$complete,
				$informationUrl,
				$imageUrl,
				$comments
			);
			return $items;
		}
				
}
?>
