<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is release under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
//include ('plugins/genealogy/sql/informationQueries.php');
require_once ('base/model/Information.php');
require_once ('base/model/InformationFactory.php');
require_once ('base/model/Services.php');
/**
 * Person operations. The BusinessLogic operations 
 *
 * @author Barry Nauta
 * @date January 2004
 * @package be.nauta.booby.plugins.genealogy.model
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta <br />
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code> 
 * and look for licenses
 */
class InformationServices extends Services
{
	
	/**
	 * Default constructor
	 */
	function InformationServices ()
	{
		parent :: Services ();
		$this->itemFactory = new InformationFactory ();

		include ('plugins/genealogy/sql/informationQueries.php');
		$this->queries = $queries;
	}
	 
	/**
	 * Adds an item
	 * 
	 * @param integer userId the identifier for the user
	 * @param object item the item to be added
	 *
     * @return integer last know id. This is the id of the contact
	 * that was newly inserted and for which an id has automatically
	 * been assigned.
	 */
	function addItem ($userId, $item)
	{
//die ($item->description);
 //       if ($_SESSION['username'] != $userId) { return null; }

        global $db;

		$now = date ("Y-m-d H:i:s");
		$query  = sprintf ($this->queries['addItem'],
			$userId, 
			addslashes ($item->parentId),
			addslashes ($item->isParent),
			addslashes ($item->name),
			addslashes ($item->description),
			addslashes ($item->visibility),
			addslashes ($item->category),
			addslashes ($now),
			addslashes ($item->referingId),
			addslashes ($item->referingType),
			addslashes ($item->reliability),
			addslashes ($item->complete),
			addslashes ($item->informationURL),
			addslashes ($item->imageURL),
			addslashes ($item->comments));
		$result = $db->Execute($query) 
			or die("Add: " . $db->ErrorMsg() . " " . $query);
	}

	/**
	 * Modifies an item.
	 *
 	 * @param integer userId the identifier for the user who modifies a note
	 * @param object item the modified note
	 */
	function modifyItem ($userId, $item)
	{
//        if ($_SESSION['username'] != $userId) { die ($_SESSION['username'] . '*'.$userId);return null; }
		$this->checkOwner ($userId, $item->itemId);
        global $db;
		$now = date ("Y-m-d H:i:s");

		$query  = sprintf ($this->queries['modifyItem'],
			$now,
			addslashes ($item->name),
			addslashes ($item->description),
			addslashes ($item->parentId),
			addslashes ($item->referingId),
			addslashes ($item->referingType),
			addslashes ($item->reliability),
			addslashes ($item->complete),
			addslashes ($item->informationURL),
			addslashes ($item->imageURL),
			addslashes ($item->comments),
			$item->itemId) ;
//die ($query);
		$result = $db->Execute($query) 
			or die("Modify: " . $db->ErrorMsg() . " " . $query);
	}
	
	/**
	 * Gets a specific item for a user for the specific type
	 *
	 * @param string userId the identifier for the user
	 * @param string itemId the identifier for the item
	 * @param string type the type of information (person etc)
	 * @return object the item for specified user with specified itemId  
	 */
	function getItems ($userId, $itemId, $type)
	{
//		if ($_SESSION['username'] != $userId) { return null; }

		global $db;
		$query = sprintf ($this->queries['getItemsForType'], $userId, $itemId, $type);
		$result = $db->Execute($query) or
			die("GetItem: " .
			$db->ErrorMsg() . " query: -" .
			$query . "-");

		$items = $this->itemFactory->resultsetToItems ($result);
		if (count ($items) == 0)
		{
			return null;
		}
		else
		{
			if ($items[0]->owner == $userId)
			{
				return $items;
			}
			die ("Not owner?");	
		}
	}
	
}
?>
