<?php
/*
 * vim: set tabstop=4 : 
 * vim: set number : 
 *
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('base/model/ItemFactory.php'); 
require_once ('base/model/Preference.php');
/**
 * PluginSetting Factory
 *
 * @author Barry Nauta July 2004
 * @package be.nauta.booby.base.model
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code>
 * and look for licenses
 */
class PluginSettingFactory extends ItemFactory
{
	/**
	 * Default constructor
	 */
	function PluginSettingFactory ()
	{
		parent::ItemFactory();
	}
	
	/**
	 * Factory method. Return an HTTP request into an item by fecthing
	 * the appropriate parameters from the POST request
	 *
	 * @return object the item constructed from the POST request
	 */
	function requestToItem ()
	{
			$visibility = $this->getFromPost ('visibility', 'private');
			$loginName = $this->getFromPost ('loginName', null);
			$parentId = $this->getFromPost ('parentId', 0);
			$isParent = $this->getFromPost ('isParent', 0);
			$when_created = $this->getFromPost ('when_created', null);
			$when_modified = $this->getFromPost ('when_modified', null);
			$itemId = $this->getFromPost ('itemId', 0);
			$category = $this->getFromPost ('category', null);
			$value = $this->getFromPost ('value', null);
			$name = $this->getFromPost ('name', null);
			$description = $this->getFromPost ('description', null);
			
			$item = new PluginSetting 
			(
				$itemId,
				$loginName,
				$parentId,
				$isParent,
				$name,
				$description,
				$visibility,
				$category,
				$when_created,
				$when_modified,
				$value
			);
			return $item;
	}
	
	/**
	 * Factory method: Returns a database result into an item
	 *
	 * @param object result the result retrieved from the database
	 * @return array the items constructed from the database resultset
	 */
	function resultsetToItems ($result)
	{
			$items = array ();
			while (!$result -> EOF)
			{
				$item = new PluginSetting 
				(
					$result->fields['itemId'],
					$result->fields['owner'],
					$result->fields['parentId'],
					$result->fields['isParent'], 
					$result->fields['name'],
					$result->fields['description'],
					$result->fields['visibility'],
					$result->fields['category'],
					$result->fields['when_created'],
					$result->fields['when_modified'],
					$result->fields['value']
				);
				$items [] = $item;
				$result->MoveNext ();
			}
			return $items;
	}
	
	/**
	 * Creates a simple pluginsetting by only setting the default values
	 * @param string owner the owner of the setting
	 * @param string name the name of the setting
	 * @param value the value of the setting
	 */ 
	function getPluginSetting ($owner, $name, $value)
	{
		return new PluginSetting
		(
			0,
			$ower,
			0,
			0,
			$name,
			null,
			'private',
			null,
			null,
			null,
			$value
		);
	}	
}
?>
