<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('base/util/StringUtils.php');
require_once ('base/model/Item.php');
/**
 * A preference item. A preference item is basically a name/value pair
 * which extends item so it can inherit all items functionality
 *
 * @author Barry Nauta January 2004
 * @package be.nauta.booby.base.model
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta <br />
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code>
 * and look for licenses
 */
class Preference extends Item
{
	/**
	 * The value (a preference is basically a name/value pair)
	 * @var string 
	 */
	var $value;
	
	/**
 	 * Full blown constructor
	 *
	 * @param integer theItemId the itemId
	 * @param string theOwner the owner
	 * @param integer theParentId the identifier of the parent
	 * @param boolean parent is this a parent yes or no?
	 * @param string theName the name of this item
	 * @param string theDescription the decription
	 * @param string theVisibility private or public
	 * @param string theCategory the category
	 * @param string theCreation when was this item created?
	 * @param string theModified when was this item last modified?
	 * @param string value the value of the specific preference
	 */
	function Preference ($theItemId, $theOwner, $theParentId, $parent,
		$theName, $theDescription,
		$theVisibility, $theCategory, $theCreation, $theModified, $theValue)
	{
		parent :: Item (
				$theItemId, 
				$theOwner, 
				$theParentId, 
				$parent,
				$theName, 
				$theDescription, 
				$theVisibility,
				$theCategory, 
				$theCreation, 
				$theModified);
					
		$this->type="Preference";
		$this->value = $theValue;
	}
}
?>
