<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 Barry Nauta
 *
 * The Booby project is release under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
/**
 * Item queries, these are 'abstract' queries. 
 * Tablename need to be specified by the file that includes these queries
 * 
 * @package be.nauta.booby.base.database
 * @author Barry Nauta
 * @copyright
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: <code>http://www.gnu.org</code> and look for licenses
 */
$queries=array ();

// queries containing 'public' : some modified by Michael
// getItem modified by Michael : removed owner
$queries['getItem']=
		"SELECT * from " . $tableName . " WHERE itemId=%d";
$queries['getPublicItem']=
		"SELECT * from " . $tableName . " WHERE itemId=%d AND (owner='%s' OR visibility='public')";
		
$queries['getItems']=
		"SELECT * from " . $tableName . " WHERE owner='%s' ".
		"ORDER BY 'isParent' DESC, 'name' ASC";
$queries['getPublicItems']=
		"SELECT * from " . $tableName . " WHERE owner='%s' OR visibility='public' ".
		"ORDER BY 'isParent' DESC, 'name' ASC";
		
$queries['getSortedItems']=
		"SELECT * FROM " . $tableName . " WHERE owner='%s' and parentId=%d ".
		"ORDER BY '%s' %s";
$queries['getAllSortedItems']=
		"SELECT * FROM " . $tableName . " WHERE owner='%s' ".
		"ORDER BY '%s' %s";
		
$queries['getPublicSortedItems']=
		"SELECT * FROM " . $tableName . " WHERE parentId=%d and (owner='%s' OR visibility='public') ".
		"ORDER BY '%s' %s";
		
$queries['getAllPublicSortedItems']=
		"SELECT * FROM " . $tableName . " WHERE owner='%s' OR visibility='public' ".
		"ORDER BY '%s' %s";

$queries['getItemChildren']=
		"SELECT * from ". $tableName .
		" WHERE parentId=%d AND owner='%s' ".
		"ORDER BY 'isParent' DESC, 'name' ASC";
		
$queries['getPublicItemChildren']=
		"SELECT * from ". $tableName .
		" WHERE parentId=%d AND (owner='%s' OR visibility='public') ".
		"ORDER BY 'isParent' DESC, 'name' ASC";

$queries['getPublicItemChildrenForUser']=
		"SELECT * from ". $tableName .
		" WHERE parentId=%d AND owner='%s' AND visibility='public' ".
		"ORDER BY 'isParent' DESC, 'name' ASC";

$queries['searchItems']=
		"SELECT * from ".$tableName . 
		" WHERE %s LIKE '%%%s%%' and owner='%s' ".
		"ORDER BY 'isParent' DESC, 'name' ASC";
		
$queries['searchPublicItems']=
		"SELECT * from ".$tableName . 
		" WHERE %s LIKE '%%%s%%' AND (owner='%s' OR visibility='public') ".
		"ORDER BY 'isParent' DESC, 'name' ASC";
		
$queries['getItemChildrenThatAreParent']=
		"SELECT * from ". $tableName .
		" WHERE parentId=%d AND owner='%s' AND isParent=1 ".
		"ORDER BY 'isParent' DESC, 'name' ASC";
		
$queries['getPublicItemChildrenThatAreParent']=
		"SELECT * from ". $tableName .
		" WHERE parentId=%d AND isParent=1 AND (owner='%s' OR visibility='public') ".
		"ORDER BY 'isParent' DESC, 'name' ASC";
		
$queries['getItemOwner']=
		"SELECT owner from " . $tableName . " WHERE itemId=%d";
		
$queries['lastItemInsertId']=
		"SELECT last_insert_id() FROM " . $tableName;
		
$queries['deleteItem']=
		"DELETE from " . $tableName . " WHERE itemId=%d";
		
$queries['updateItemVisitCount']=
		"UPDATE ".$tableName .
		" SET visitCount=visitCount+1 ".
		"WHERE itemId=%d";

// added by Michael.
// We could put the fields names into a config file (this is what I do with my datamodel)
$queries['getParent']=
		"SELECT DISTINCT parent.itemId, parent.owner, parent.parentId, ".
		" parent.name, parent.description, parent.visibility, parent.when_created, parent.when_created ".
		" from " . $tableName . " parent, " . $tableName . " self".
		" WHERE self.itemId=%d ".
		" AND self.parentId = parent.itemId";
		
$queries['getChildrenCount']=
		"SELECT count(*) FROM ". $tableName .
		" WHERE parentId=%d AND owner='%s' AND isParent <> 1 ";
		
$queries['getPublicChildrenCount']=
		"SELECT count(*) FROM ". $tableName .
		" WHERE parentId=%d AND isParent <> 1 AND (owner='%s' OR visibility='public') ";

$queries['getItemCount']=
		"SELECT count(*) FROM ".$tableName." WHERE owner='%s'";
$queries['getDashboard']=
		"SELECT * FROM " . $tableName . " WHERE owner='%s' and isParent=0 ".
		"ORDER BY '%s' %s";
