<?php
/*
 * vim: set number :
 * vim: set tabstop=4 :
 *
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
/**
 *
 * This class offers utility methods for manipulation of classes and 
 * objects.
 *
 * @package be.nauta.booby.base.util
 * @author Michael Haussmann 05/11/2003
 * @copyright Michael Haussmann
 * @access static
 */
class ClassHelper 
{
	/**
 	 * This method casts one object into another.
	 * 
	 * Some behaviours are a little bit unexpected : 
	 * the object may end up with attributs that are not defined in 
	 * it's class.
	 *
	 * This is a usefull workaround, but has to be re-written at some 
	 * time.
	 *
	 * @author post_at_henribeige_dot_de sur le manuel PHP
	 * "All variables that equal name in both classes will be copied."
	 * (PHP Manual note by post_at_henribeige_dot_de, 03-May-2003 06:37)
	 *
	 *
	 * @static
	 * @return object a new object of type $new_classname
	 */
	function typecast($old_object, $new_classname) 
	{
		
		/* TODO :
		
		Certainement  rcrire  terme.
		
		PB exceptions
		tester les effets de bords
		vrifier la performance
		problme : cre des variables membres qui n'existent pas dans la classe, et qui rsultent de la requte!
		
		*/
		if(class_exists(strtolower($new_classname))) {
			$old_serialized_object = serialize($old_object);
			$old_classname = get_class($old_object);
			$oldObjectBodySize = strlen("O:".strlen($old_classname).":".$old_classname.":");
			$objectBody = substr($old_serialized_object, $oldObjectBodySize+1);
			$new_serialized_object = 'O:' . strlen($new_classname) . ':"' . $new_classname . "\"" . $objectBody;
			return unserialize($new_serialized_object);
		}else {
			return false;
		}
	}
	
	/**
	 * Clone an object
	 *
	 * @author Christian Schneider
	 * From [PHP-DEV] Feature request: clone() function
	 * @param object the object to clone
	 * @return object a cloned object
	 */
	function &clone(&$object)
	{
		return (is_object($object) && version_compare(zend_version(), '2.0.0-dev', '<')) ? $object : $object->__clone();
	}
	
	/**
	 * Gets into an array all the ancestors of the given class, 
	 * starting with the class itself and upwards.
	 * 
	 * Example result : 
	 * <pre>
	 * Array
	 * (
	 * 	[0] => me
	 * 	[1] => father
	 *	    [2] => grandfather
	 * )
	 * </pre>
	 *
	 * @author tim at correctclick dot com
	 * (PHP Manual) 05-Apr-2003 07:48
	 * @return array the ancestors of a base class
	 * @todo should 'me' be in the list of ancestors? Seems a bit odd :-)
	 */
	function get_ancestors ($class) {
		
		for ($classes[] = $class; $class = get_parent_class ($class); $classes[] = $class);
		return $classes;
	}
}
