<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
/**
 * HTML utilities
 * @package be.nauta.booby.base.util
 * @author Barry Nauta January 2004
 *
 * @copyright
 *
 * Copyright (c) 2003 - 2004 Barry Nauta 
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code>
 * and look for licenses
 * @todo what ever happend to the line function??
 */
class HTMLUtils
{
	/**
	 * Empty constructor
	 */
	function HTMLUtils ()
	{
	}
	
	/**
	 * Draws a horizontal line with given offest, length and color (not to confuse with the
	 * &lt;hr /&gt; tag!)
	 *
	 * @param int x the x offset
	 * @param int y the y offset
	 * @param int length the length of the line
	 * @param string color the color of the line
	 */
	function horizontalLine ($x, $y, $length, $color="#000000")
	{
		$resultString = '<div ';
		$resultString .= 'style="position:absolute;';
		$resultString .= 'background-color:'.$color.'; ';
		$resultString .= 'top:'.$x.';';
		$resultString .= 'left:'.$y.';';
		$resultString .= 'height:1;';
		$resultString .= 'width:'.$length.';';
		$resultString .= 'z-index:3 ';
		$resultString .= '></div>
		';
		return $resultString; 
	}
	
	/**
	 * Draws a vertical line with given offest, length and color (not to confuse with the
	 * &lt;hr /&gt; tag!)
	 *
	 * @param int x the x offset
	 * @param int y the y offset
	 * @param int length the length of the line
	 * @param string color the color of the line
	 */
	function verticalLine ($x, $y, $length, $color="#000000")
	{
		$resultString = '<div ';
		$resultString .= 'style="position:absolute;';
		$resultString .= 'background-color:'.$color.'; ';
		$resultString .= 'top:'.$x.';';
		$resultString .= 'left:'.$y.';';
		$resultString .= 'height:'.$length.';';
		$resultString .= 'width:1;';
		$resultString .= 'z-index:3 ';
		$resultString .= '></div>
		';
		return $resultString; 
	}

	function cellOutline ($top, $left, $height, $width, $zIndex)
	{
		$resultString  = '<div ';
		$resultString .= line ('#000000', $top, $left, $height, $width, $zIndex);
		$resultString .= '"></div>';
		return $resultString; 
	}
	function cellShading ($top, $left, $height, $width, $zIndex)
	{
		$resultString  = '<div ';
		$resultString .= line ('#bbbbbb', $top, $left, $height, $width, $zIndex);
		$resultString .= '"></div>';
		return $resultString; 
	}
	
	function tableCell ($bgColor, $top, $left, $height, $width, $zIndex)
	{
		$resultString = line ($bgColor, $top, $left, $height, $width, $zIndex);
		$resultString .= "clip:rect(auto auto ".$height.".px auto)";
		return $resultString; 
	}
	function cell ($bgColor, $top, $left, $height, $width, $name)
	{
		$resultString  = '<div ';
		$resultString .= tableCell ($bgColor, $top, $left, $height, $width, 5);
		$resultString .= '">';
		$resultString .= '<table border="0" cellpadding="5" cellspacing="0" align="center" valign="center">';
		$resultString .= '<tr><td height="'.$height.'"><span style="font-size:11pt">'.$name.'</span></td></tr>'; 
		$resultString .= '</table>';
		$resultString .= '</div>';
		$resultString .= cellOutline ($top-1, $left-1, $height+2, $width+2, 4);
		$resultString .= cellShading ($top+3, $left+3, $height+2, $width+2, 1);
		return $resultString; 
	}
	
}
?>
