<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('base/util/StringUtils.php');
/**
 * Item utilities
\ *
 * @author Barry Nauta December 2003
 * @package be.nauta.booby.base.util
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta 
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code> 
 * and look for licenses
 */
class ItemUtils
{
	/**
	 * Empty default constructor
	 */
	function ItemUtils ()
	{
	}
	
	/**
	 * Export users items (starting from a certain Id)
	 * 
	 * @param string id the identifier for the user
	 * @param integer parent the identifier for the parent id of the items
	 * (to enable recursive functioncall)
	 */
	function exportItemsToHTML ($id, $parent, $callback) 
	{
	  	$items = $callback->getChildren ($id, $parent);
	
	  	for ($i=0;$i<count($items); $i++)
	  	{
			$item = $items[$i];
			// Folder. Perform a recursive callback	
    		if ($item->isParent == '1') 
			{ 
	      			$this->exportItemsToHTML
					($id, $item->itemId, $callback);
    		} 
    		else
    		{
				echo ($item->toHTML());
			}
    	}
	}
	
	/**
	 * Export users items (starting from a certain Id) to 
	 * comma-seperated-value (CSV) format.
	 * This function does not work yet....
	 * 
	 * @param string id the identifier for the user
	 * @param integer parent the identifier for the parent id of the items
	 * (to enable recursive functioncall)
	 */
	function exportItemsToCSV ($id, $parent, $callback) 
	{
	  	$items = $callback->getChildren ($id, $parent);
	
	  	for ($i=0;$i<count($items); $i++)
	  	{
			$item = $items[$i];
			// Folder. Perform a recursive callback	
    		if ($item->isParent == '1') 
			{ 
	      			$this->exportItemsToHTML
					($id, $item->itemId, $callback);
    		} 
    		else
    		{
				echo (implode(",", get_object_vars ($item)));
				echo ('
');
			}
    	}
	}
}
?>
