<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
/**
 * This class provides BASIC logging functionalities
 *
 * @package be.nauta.booby.base.util
 * @author Barry Nauta March 2003
 *
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code>
 * and look for licenses
 */
class Logger
{
	/**
	 * The file (name) to which we log
	 * @var string 
	 */
	var $file;
	
	/**
	 * The format for the timestamp 
	 * @var string 
	 */
	var $timeFormat = "%H:%M:%S";

	/**
 	 * Constructor with a filename
 	 * @param string aFilename the filename to which we want to log
	 */
	function Logger ($aFileName)
	{
		$this->file = $aFileName;
	}

	/**
 	 * Log the message (timestamp will be prepended)
	 *
	 * @param string message the message to log
 	 */
	function log ($message)
	{
		$fd = fopen ($this->file, "a");
		if ((!$fd))
		{
			die ("Could not open: " + $file);
		}
		if (empty($fd))
		{
			die ("Empty");
		}
		$msg = $message . "\n";

		$timeStamp = strftime($this->timeFormat, time());
		fwrite ($fd, $timeStamp . " " . $msg);
		fclose ($fd);
	}
}
?>
