<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is release under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ("base/util/StringUtils.php");
require_once ('base/view/TreeDelegate.php');
/**
 * Used in combination with the PHPItemTree class
 *
 * @author Barry Nauta
 * @date July 2003
 * @package be.nauta.booby.base.view
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta <br />
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code> 
 * and look for licenses
 */
class MoveMultipleItemsExplorerTreeDelegate extends TreeDelegate
{
	/**
	 * Default constructor
	 */
	function MoveMultipleItemsExplorerTreeDelegate ($theConfiguration)
	{
		parent::TreeDelegate ($theConfiguration);
	}
	
	/**
	 * Builds up html code to display the root of the tree
	 * @private
	 *
	 * @param object item the item that is the root of the tree
	 */
	function showRoot ($item, $tree)
	{
		$this->itemToMove = $item;
		$resultString  = '<h3><a href="'.$this->configuration['callback'];
		$resultString .= '?action=moveMultipleItemsPost&parentId=0';
		$resultString .= '&itemIds='.$this->configuration['multipleItems'].'">'.$this->configuration['icons']['root'].'</h3>';
		return $resultString;
	}
	
	/**
	 * If the specified item is a folder, draw it
	 * @private
	 * @param object item the item to draw
	 * @param boolean isExpanded whether this folder is expanded (i.e. do the
	 * children of this folder need to be displayed as well?)
	 * @param object tree the tree that uses this class as delegate
	 * @return string the string for this folder
	 */
	function drawFolder ($item, $isExpanded, $tree, $indentLevel)
	{
		// do not include the item itself incase the item is a folder
		// we do not want to have a folder which is its own parent
		if ($item->itemId == $this->itemToMove->itemId)
		{
			return '';
		}	
		$resultString = '
								<tr><td>';
								
		for ($i=0; $i<$indentLevel; $i++)
		{
			$resultString .= $this->configuration['icons']['bar'];
		}
	
		$resultString .= $this->configuration['icons'] ['minus'];
		$resultString .= $this->configuration['icons'] ['folder_open'];
		$resultString .= '<a href="'.$this->configuration['callback'];
		$resultString .= '?action=moveMultipleItemsPost&parentId='.$item->itemId;
		$resultString .= '&itemIds='.$this->configuration['multipleItems'].'">'.$item->name;
		$resultString .= '</td></tr>';

		return $resultString;
	}
	
	
	/**
	 * If the specified item is a node, draw it
	 * @private
	 * @param object item the item to draw
	 * @param boolean lastNode whether this node is the last one
	 * @return string the string for this node
	 */
	function drawNode ($item, $lastNode, $tree, $indentLevel)
	{
		// no nodes need to be drawn when moving an item, we can only move
		// to folders
		return '';
	}	
}
?>