<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is release under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ("base/util/StringUtils.php");
require_once ('base/view/TreeDelegate.php');
/**
 * Used in combination with the Tree abstract base classes
 *
 * @author Barry Nauta
 * @date February 2004
 * @package be.nauta.booby.base.view
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta <br />
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code> 
 * and look for licenses
 */
class MultipleSelectExplorerTreeDelegate extends TreeDelegate
{
	/**
	 * Default constructor
	 */
	function MultipleSelectExplorerTreeDelegate ($theConfiguration)
	{
		parent::TreeDelegate ($theConfiguration);
	}
	
	/**
	 * Builds up html code to display the root of the tree
	 * @private
	 *
	 * @param object item the item that is the root of the tree
	 */
	function showRoot ($item, $tree)
	{
		$resultString = '<h3>'.$this->configuration['icons']['root'].'</h3>';
		return $resultString;
	}
	
	/**
	 * If the specified item is a folder, draw it
	 * @private
	 * @param object item the item to draw
	 * @param boolean isExpanded whether this folder is expanded (i.e. do the
	 * children of this folder need to be displayed as well?)
	 * @param object tree the tree that uses this class as delegate
	 * @return string the string for this folder
	 */
	function drawFolder ($item, $isExpanded, $tree, $indentLevel)
	{
		$resultString = '
								<tr>';
		$resultString .= '<td>&nbsp;</td><td>';						
		for ($i=0; $i<$indentLevel; $i++)
		{
			$resultString .= $this->configuration['icons']['bar'];
		}
	
		$resultString .= $this->configuration['icons']['minus'];
		$resultString .= $this->configuration['icons']['folder_open'];
		$resultString .= $item->name;
		$resultString .= '</td></tr>';

		return $resultString;
	}
	
	
	/**
	 * If the specified item is a node, draw it
	 * @private
	 * @param object item the item to draw
	 * @param boolean lastNode whether this node is the last one
	 * @return string the string for this node
	 */
	function drawNode ($item, $lastNode, $tree, $indentLevel)
	{
		$resultString  = '<tr>';
		$resultString .= '<td><input type="checkbox" name="'.$item->itemId.'" value="itemId"></td>';
		$resultString .= '<td>';
		for ($i=0; $i<$indentLevel; $i++)
		{
			$resultString .= $this->configuration['icons']['bar'];
		}
		if ($lastNode)
		{
			$resultString .= $this->configuration['icons']['corner'];
		}	
		else
		{
			$resultString .= $this->configuration['icons']['tee'];
		}
		$resultString .= $this->configuration['icons']['node'];
		
		$resultString .= $this->stringUtils->gpcAddSlashes ($this->stringUtils->urlEncode ($item->name));
		
		$resultString .= '</td></tr>';
		return $resultString;
	}	
}
?>
