<?php
/*
 * vim: set number :
 * vim: set tabstop=4 :
 *
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
include_once ("base/util/StringUtils.php");
/**
 * Abstract base class used in combination with the Tree, YahooTree or 
 * LineBasedTree
 *
 * @author Barry Nauta
 * @date Februari 2004
 * @package be.nauta.booby.base.view
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta 
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code> 
 * and look for licenses
 */
class TreeDelegate
{
	/**
	 * String utilities
	 * @private
	 * @variable object stringUtils
	 */
	var $stringUtils;
	
	/**
	 * 
	 */
	var $configuration;
	
	/**
	 * Default constructor
	 * @param array theConfiguration. This configuration must contain the 
	 * following items:
	 * <ul>
	 * <li>icons. Icons in an hashtable. The icons must have the following 
	 * keys:
	 * 	<ul>
	 			<li>'bar'</li>
	 			<li>'up'</li>
	 			<li>'minus'</li>
	 			<li>'folder_open'</li>
	 			<li>'corner'</li>
	 			<li>'plus'</li>
	 			<li>'tee'</li>
	 			<li>'folder_closed'</li>
	 			<li>'node'</li>
	 			<li>'before_display'</li>
	 			<li>'after_display'</li>
	 			<li>'add'</li>
	 			<li>'delete'</li>
	 			<li>'edit'</li>
	 			<li>'up_arrow_shaded'</li>
	 			<li>'up_arraw'</li>
	 			<li>'down_arrow'</li>
	 			<li>'down_arrow_shaded'</li>
	 		</ul>
	 * </li>
	 * <li>callback. The URL to the callback, typically the controller</li>
	 * <li>dictionairy. The dictionary that is used</li>
	 * </ul>
	 */
	function TreeDelegate ($theConfiguration)
	{
		$this->configuration = $theConfiguration;
		$this->stringUtils = new StringUtils ();
	}
	
	/**
	 * Renders the sort arrows
	 * @param string sortField the field on which we would like
	 * to sort
	 * @param integer parentId the current parentId
	 */
	function sortArrows ($sortField, $parentId)
	{
		$resultString = '&nbsp;';
		$resultString .= '<a href="'.$this->configuration['callback'];
		$resultString .= '?action=sort&order=ASC&field='.$sortField.'&parentId='.$parentId;
		if (isset ($_GET['order']) && $_GET['order'] == 'ASC' && $_GET['field'] == $sortField)
		{
			$resultString .= '">'.$this->configuration['icons']['up_arrow_shaded'].'</a>';
		}
		else
		{
			$resultString .= '">'.$this->configuration['icons']['up_arrow'].'</a>';
		}
		$resultString .= '<a href="'.$this->configuration['callback'];
		$resultString .= '?action=sort&order=DESC&field='.$sortField.'&parentId='.$parentId;
		if (isset ($_GET['order']) && $_GET['order'] == 'DESC' && $_GET['field'] == $sortField)
		{
			$resultString .= '">'.$this->configuration['icons']['down_arrow_shaded'].'</a>';
		}
		else
		{
			$resultString .= '">'.$this->configuration['icons']['down_arrow'].'</a>';
		}
		return $resultString;
	}
	
	
	/**
	 * Returns the overlib javascript 
	 * @param string title the title of the popup
	 * @param string text the text of the popup
	 */
	function overLib ($title, $text)
	{
			$resultString  = 'onmouseover="return overlib(\'';
			$resultString .= $this->stringUtils->urlEncode (addslashes ($text));
			$resultString .= "', CAPTION, '";
			$resultString .= $this->stringUtils->urlEncode(addslashes ($title)) . '\');" ';
			$resultString .= 'onmouseout="return nd();" ';
			return $resultString;
	}

}
?>
