<?php

function addExpandedChildren (&$item, $services, $userName)
{
	if ($item->isParent () && $isExpanded ($item->itemId))
	{
		$items = $services->getPublicChildren
			($userName (),$item->itemId);
		for ($i=0; $i<count($items); $i++)
		{
			addExpandedPublicChildren ($items[$i]);
			$item->addChild ($items[$i]);
		}
	}
}

function getExpanded ()
{
	if (isset ($_GET['expand']))
	{
		$expand = $_GET['expand'];
		$_SESSION[$this->expandName]=$expand;
	}
	else if (isset ($_SESSION[$this->expandName]))
	{
		$expand = $_SESSION[$this->expandName];
	}
	else
	{
		$expand = 0;
	}
	return $expand;
}

function isExpanded ($itemId)
{
	$expanded = explode (",", $this->getExpanded ());
	if ($this->getExpanded () == null)
	{
		return false;
	}
	// wildcard implementation
	if (count ($expanded == 1) && $expanded[0] == "*")
	{
		$this->addExpanded ($itemId);
		return true;
	}
	while (list ($key, $val) = each($expanded))
	{
		// yep, in the expanded list
		if ($val == $itemId)
		{
			// we might want to remove it from
			// the expanded list and put it in
			// the parsedExpanded list
			return true;
		}
	}
	return false;
}


$userName = $_GET['username'];
$plugin = $_GET['plugin'];
if (isset ($userName))
{
	if ($plugin == 'bookmarks')
	{
		include ('plugins/bookmarks/model/BookmarkServices.php');
		$services = new BookmarkServices ();
	}

	$rootItems = $services->getPublicChildrenForUser ($userName, 0);
	$expanded = getExpanded ();
	for ($i=0; $i<count($root); $i++)
	{
		addExpandedChildren ($rootItems[$i]);
	}
	
	require_once ('base/view/Tree.php');
	require_once ('plugins/bookmarks/view/BookmarkExplorerTreeDelegate.php');
	
	$delegate = new BookmarkExplorerTreeDelegate ($configuration);
	$tree = new Tree ($delegate, $configuration);
	echo $tree->toHtml ($root, $rootItems);
	die (print_r ($rootItems));
}
else
{
	include ('base/config/plugins.php');
	$thePlugin = $plugins[$plugin];
	include ($thePlugin['controller']);
	$controller = new $thePlugin['controllerName'] ();
	$controller->activate ();
	$controller->display ();
}
?>
