<?php
/**
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 * @package be.nauta.booby.install
 * @author Barry Nauta January 2004
 * @copyright Barry Nauta	
 */
define (NEWVERSION, "0.3.4"); 

function getCreateTableQueries ()
{
	$queries = array ();
	$queries['create_mysql_booby_user_preferences']="
		create table booby_user_preferences (
			itemId integer auto_increment not null primary key,
			owner	char (70) not null,
			parentId integer not null,
			isParent BOOL,
			name char (70) not null,
			description text,
			visibility char (15),
			category char (50),
			when_created DATETIME,
			when_modified DATETIME,
			value char (50),
			key (itemId)
		)
	";
	$queries['create_postgres_booby_user_preferences']="
		create table booby_user_preferences (
			itemId serial not null,
			owner	char (70) not null,
			parentId integer not null,
			isParent BOOL,
			name char (70) not null,
			description text,
			visibility char (15),
			category char (50),
			when_created timestamp,
			when_modified timestamp,
			value char (50),
			primary key (itemId)
		)
	";
	$queries['create_mysql_booby_plugin_settings']="
		create table booby_plugin_settings (
			itemId integer auto_increment not null primary key,
			owner	char (70) not null,
			parentId integer not null,
			isParent BOOL,
			name char (70) not null,
			description text,
			visibility char (15),
			category char (50),
			when_created DATETIME,
			when_modified DATETIME,
			value char (50),
			key (itemId)
		)
	";
	$queries['create_postgres_booby_plugin_settings']="
		create table booby_plugin_settings (
			itemId serial not null,
			owner	char (70) not null,
			parentId integer not null,
			isParent BOOL,
			name char (70) not null,
			description text,
			visibility char (15),
			category char (50),
			when_created timestamp,
			when_modified timestamp,
			value char (50),
			primary key (itemId)
		)
	";
	$queries['create_mysql_booby_bookmarks']="
		create table booby_bookmarks (
			itemId integer auto_increment not null primary key,
			owner	char (70) not null,
			parentId integer not null,
			isParent BOOL,
			name char (70) not null,
			description text,
			visibility char (15),
			category char (50),
			when_created DATETIME,
			when_modified DATETIME,
			when_visited DATETIME,
			locator text,
			visitCount int (11),
			key (itemId)
		)
	";
	$queries['create_postgres_booby_bookmarks']="
		create table booby_bookmarks (
			itemId serial not null,
			owner	char (70) not null,
			parentId integer not null,
			isParent BOOL,
			name char (70) not null,
			description text,
			visibility char (15),
			category char (50),
			when_created timestamp,
			when_modified timestamp,
			when_visited timestamp,
			locator text,
			visitCount int (11),
			primary key (itemId)
		)
	";
	$queries['create_mysql_booby_contacts']="
		create table booby_contacts (
			itemId integer auto_increment not null primary key,
			owner	char (70) not null,
			parentId integer not null,
			isParent BOOL,
			name char (70) not null,
			description text,
			visibility char (15),
			category char (50),
			when_created DATETIME,
			when_modified DATETIME,
			alias char (70),
			address TEXT,
			birthday DATETIME,
			mobile char (25),
			faximile char (25),
			tel_home char (25),
			tel_work char (25),
			organization char (70),
			org_address TEXT,
			job char (70),
			email1 char (70),
			email2 char (70),
			email3 char (70),
			webaddress1 char (70),
			webaddress2 char (70),
			webaddress3 char (70),
			key (itemId)
		)
	";
	$queries['create_postgres_booby_contacts']="
		create table booby_contacts (
			itemId serial not null,
			owner	char (70) not null,
			parentId integer not null,
			isParent BOOL,
			name char (70) not null,
			description text,
			visibility char (15),
			category char (50),
			when_created timestamp,
			when_modified timestamp,
			alias char (70),
			address TEXT,
			birthday timestamp,
			mobile char (25),
			faximile char (25),
			tel_home char (25),
			tel_work char (25),
			organization char (70),
			org_address TEXT,
			job char (70),
			email1 char (70),
			email2 char (70),
			email3 char (70),
			webaddress1 char (70),
			webaddress2 char (70),
			webaddress3 char (70),
			primary key (itemId)
		)
	";
	$queries['create_mysql_booby_news']="
		create table booby_news (
			itemId integer auto_increment not null primary key,
			owner	char (70) not null,
			parentId integer not null,
			isParent BOOL,
			name char (70) not null,
			description text,
			visibility char (15),
			category char (50),
			when_created DATETIME,
			when_modified DATETIME,
			when_visited DATETIME,
			locator char (70),
			visitCount int (11),
			key (itemId)
		)
	";
	$queries['create_postgres_booby_news']="
		create table booby_news (
			itemId serial not null,
			owner	char (70) not null,
			parentId integer not null,
			isParent BOOL,
			name char (70) not null,
			description text,
			visibility char (15),
			category char (50),
			when_created timestamp,
			when_modified timestamp,
			when_visited timestamp,
			locator char (70),
			visitCount int (11),
			primary key (itemId)
		)
	";
	$queries['create_mysql_booby_notes']="
		create table booby_notes (
			itemId integer auto_increment not null primary key,
			owner	char (70) not null,
			parentId integer not null,
			isParent BOOL,
			name char (70) not null,
			description text,
			visibility char (15),
			category char (50),
			when_created DATETIME,
			when_modified DATETIME,
			key (itemId)
		)
	";
	$queries['create_postgres_booby_notes']="
		create table booby_notes (
			itemId serial not null,
			owner	char (70) not null,
			parentId integer not null,
			isParent BOOL,
			name char (70) not null,
			description text,
			visibility char (15),
			category char (50),
			when_created timestamp,
			when_modified timestamp,
			primary key (itemId)
		)
	";
	$queries['create_mysql_booby_todos']="
		create table booby_todos (
			itemId integer auto_increment not null primary key,
			owner	char (70) not null,
			parentId integer not null,
			isParent BOOL,
			name char (70) not null,
			description text,
			visibility char (15),
			category char (50),
			when_created DATETIME,
			when_modified DATETIME,
			priority int (11),
			startDate DATETIME,
			endDate DATETIME,
			status char (70),
			percentComplete int (11),
			isFinished tinyint (1),
			key (itemId)
		)
	";	
	$queries['create_postgres_booby_todos']="
		create table booby_todos (
			itemId serial not null,
			owner	char (70) not null,
			parentId integer not null,
			isParent BOOL,
			name char (70) not null,
			description text,
			visibility char (15),
			category char (50),
			when_created timestamp,
			when_modified timestamp,
			priority int (11),
			startDate timestamp,
			endDate timestamp,
			status char (70),
			percentComplete int (11),
			isFinished tinyint (1),
			primary key (itemId)
		)
	";	
	return $queries;
}	


function getDatabaseConnection ()
{
	@include('ext/adodb/adodb.inc.php');
	include ('base/config/databaseConfiguration.php');

	//if ($engine != 'mysql')
	//{
			//die ("Error: this script currently only works for MySQL databases");
	//}
	$db = NewADOConnection ($engine);
	$db->Connect($host, $user, $password, $database);
	return $db;
}

function getInstalledBoobyVersion ()
{
	$db = getDatabaseConnection ();
	$query = "SELECT * FROM booby_admin WHERE name='booby_version'";
	$rs = $db->Execute ($query) or die ($db->ErrorMsg ());
	return $rs->fields['value'];
}

function createDatabase ()
{
	include('ext/adodb/adodb.inc.php');
	include ('base/config/databaseConfiguration.php');
	$db = NewADOConnection ($engine);
	$db->Connect($host, $user, $password);
	$db->Execute ("create database ".$database)
		or die ($db->ErrorMsg ());
}

function createTable ($tableName)
{
	include ('base/config/databaseConfiguration.php');
	$db = getDatabaseConnection ();
	$queries = getCreateTableQueries ();
	$db->Execute ($queries ['create_'.$engine.'_'.$tableName])
		or die ($db->ErrorMsg ());
	addIndex ($tableName);	
}

function addIndex ($tableName)
{
	$db = getDatabaseConnection ();
	@$db->Execute ('create index '.$tableName.'_index on '.$tableName.' (owner, parentId)');
		//or die ($db->ErrorMsg ());
}

/**********************************************************************************
 *  D A T A B A S E 
 **********************************************************************************/
function checkAdodb ()
{
	return @include('ext/adodb/adodb.inc.php');
}

function checkDatabaseConfigurationFile ()
{
	return file_exists ('base/config/databaseConfiguration.php');
}

function connectAdodb ()
{
	@include('ext/adodb/adodb.inc.php');
	include ('base/config/databaseConfiguration.php');
	$db = NewADOConnection ($engine);
	return $db->Connect($host, $user, $password, $database);
}

function step_check_adodb ()
{
	$state_messages['adodb_found']='<h2>Adodb found</h2>
	<p>
		The file <code>base/config/databaseConfiguration.php</code>
		will be read and we will check the database credentials
	</p> ';
	
	$state_messages['adodb_not_found']='<h2>Adodb NOT found</h2>
	<p>
		Please install adodb as described in the 
		<a href="doc/installation_guide.html">Installation guide</a>
	</p>';
	if (checkAdodb ())
	{
		echo ($state_messages['adodb_found']);
		step_connect_adodb ();
	}
	else
	{
		echo ($state_messages['adodb_not_found']);
	}
}

function step_connect_adodb ()
{
	$state_messages['adodb_connected']='<h2>Database connection succesful!</h2>
		<p>
			The database will be queried for existing tables after which a check 
			will be performed if the necessary tables exist.
		</p>';
	$state_messages['adodb_not_connected']='<h2>Database connection failure!</h2>
		<p>
			Oops... could not connect to the database.  Make sure that your database
			credentials are correct by editing the file
			<code>configs/databaseConfiguration.php</code>
		</p>
		<p>
			This might also indicate that the database is not created. Click the button
			to create the database indicated in the database configuration file
		</p>
		<form method="POST" action="'.$_SERVER['PHP_SELF'].'">
			<input type="submit" value="Create database" name="create_database" />
		</form>';
	$state_messages['provide_database_configuration_file']="
		<h2>Database configuration problem</h2>
		<p>
			Please make sure that the file '<code>base/config/databaseConfiguration.php</code>'
			exists and that it contains the following parameters:
		</p>
		<ul>	
			<li>engine</li>
			<li>user</li>
			<li>password</li>
			<li>host</li>
			<li>database</li>
		</ul>
		As an example:
		<pre>
&lt;?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is release under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
$engine = 'mysql';
$user = 'root';
$password = '';
$host = 'localhost';
$database = 'booby';
?&gt;
		</pre>
	";
	if (checkDatabaseConfigurationFile ())
	{
		if (connectAdodb ())
		{
			echo ($state_messages['adodb_connected']);
			step_booby_admin_table ();
		}
		else
		{
			if (isset ($_POST['create_database']))
			{
				createDatabase ();
				step_connect_adodb ();
			}
			else
			{
				echo ($state_messages['adodb_not_connected']);
			}
		}
	}
	else
	{
		echo ($state_messages['provide_database_configuration_file']);
	}
}

/**********************************************************************************
 *  B O O B Y  -  A D M I N 
 **********************************************************************************/
function checkBoobyAdminTable ()
{
	$db = getDatabaseConnection ();
	foreach ($db->MetaTables () as $table)
	{
		if ($table == 'booby_admin')
		{
			return true;
		}
	}
	return false;
}

function createTableBoobyAdmin ()
{
	$queries ['create_booby_admin']='
		CREATE TABLE booby_admin 
		(
			name		char (70) not null,
			value		char (50),
			primary key (name)
		)
	';
	$db = getDatabaseConnection ();
	$db->Execute ($queries ['create_booby_admin'])
		or die ($db->ErrorMsg ());
}

function updateTableBoobyAdmin ()
{
	$queries ['update_booby_admin']="
		INSERT INTO booby_admin VALUES ('%s', '%s')
	";
	$queries ['insert_booby_admin']="
		INSERT INTO booby_admin VALUES ('%s', '%s')
	";

	if (
		isset ($_POST['admin_email']) && ($_POST['admin_email'] != '') &&
		isset ($_POST['allow_account_creation']) && isset ($_POST['installation_path']) &&
			($_POST['installation_path'] != 'http://')
	)
	{
		$db = getDatabaseConnection ();

		$signOn = $_POST['allow_account_creation'];
		$path = $_POST['installation_path'];
		$email = $_POST['admin_email'];

		$query=sprintf ($queries['insert_booby_admin'], 
				'allow_account_creation', $signOn);
		$db->Execute ($query) or die ($db->ErrorMsg ());

		$query=sprintf ($queries['update_booby_admin'], 
				'installation_path', $path);
		$db->Execute ($query) or die ($db->ErrorMsg ());

		$query=sprintf ($queries['update_booby_admin'], 
				'admin_email', $email);
		$db->Execute ($query) or die ($db->ErrorMsg ());

		$db->Execute ($query);
		$query=sprintf ($queries['update_booby_admin'], 
				'booby_version', NEWVERSION);
		$db->Execute ($query) or die ($db->ErrorMsg ());

		unset ($_POST['allow_account_creation']);
		unset ($_POST['installation_path']);
		unset ($_POST['admin_email']);
		return true;
	}
	else
	{
		return false;
	}
}

function checkTableBoobyAdmin ()
{
	$queries ['check_booby_admin_email']="
		SELECT value FROM booby_admin WHERE name='admin_email'
	";
	$queries ['check_booby_admin_installation_path']="
		SELECT value FROM booby_admin WHERE name='allow_account_creation'
	";
	$queries ['check_booby_admin_allow_account_creation']="
		SELECT value FROM booby_admin WHERE name='installation_path'
	";
	
	$db = getDatabaseConnection ();
	$rs = $db->Execute ($queries ['check_booby_admin_email'])
		or die ($db->ErrorMsg ().' '.$queries ['check_booby_admin_email']);
	
	if ($rs->Fields('value') == null) { return false; }
	$rs = $db->Execute ($queries ['check_booby_admin_installation_path'])
		or die ($db->ErrorMsg ().' '.$queries ['check_booby_admin_installation_path']);
	echo $rs[0];
	if ($rs->Fields('value') == null) { return false; }

	$rs = $db->Execute ($queries ['check_booby_admin_allow_account_creation'])
		or die ($db->ErrorMsg ().' '.$queries ['check_booby_admin_allow_account_creation']);
	echo $rs[0];
	if ($rs->Fields('value') == null) { return false; }
	return true;
}



function step_booby_admin_table ()
{
	$state_messages['table_booby_admin_found']='
	<h2>Table <code>booby_admin</code> found</h2>
	<p>
		We will now check whether the 4 obligatory fields (admin_email, 
		installation_path, version and allow_account_creation) are set.
	</p>
	';
	$state_messages['table_booby_admin_not_found']='
	<h2>Table <code>booby_admin</code> NOT found</h2>
	<p>
		This means that we are dealing with either and upgrade from version 
		<code>0.1.x</code> or <code>0.2.x</code> or a new install.
	</p>';
	
	$state_messages['ask_to_create_booby_admin']='
	<h2>Create table <code>booby_admin</code></h2>
	<p>
		Click the button below to execute the following statement:
		<pre>'.$queries['create_booby_admin'].'</pre>
	</p>
	<form method="POST" action="'.$_SERVER['PHP_SELF'].'">
		<input type="hidden" name="database_connection" value="connected" />
		<input type="submit" value="Create table" name="create_booby_admin" />
	</form>';
	$state_messages ['booby_admin_not_yet_filled']='
	<p>
		Obliged fields not found, please fill in the form below:
	</p>
	<form method="POST" action="'.$_SERVER['PHP_SELF'].'">
		<input type="hidden" name="database_connection" value="connected" />
		<table cellpadding="10" cellspacing="10"><tr>
				<td>Admin email:</td>
				<td><input name="admin_email"></td>
				<td>The email address of the webmaster/owner
					of this booby installation.</td>
			</tr> <tr>
				<td>Booby installation path:</td>
				<td><input name="installation_path"
					value="http://"></td>
				<td>
					What is the URL for accessing your 
					installation of booby (used for 
					quickmark functionality). Something like
					<code>http://www.nauta.be/booby</code>
				</td>
			</tr> <tr>
				<td>Allow signon</td>
				<td>
					<input name="allow_account_creation" type="radio" 
						value="1">Yes</input>
					<input name="allow_account_creation" type="radio" checked="checked"
							value="0">No</input>			
				</td>
				<td>
					Are users allowed to signon (select YES)
					or is the 
					administrator responsible for user
					creation (select NO)
				</td>
			</tr> </table>
		<input type="submit" value="Update table" name="update_booby_admin" />
	</form>';
	$state_messages['fill_in_all_required_fields']='<font color="red">
	<p>Please fill in all required fields</p></font>';
	$state_messages['booby_table_admin_filled']='<h2>Admin table ok</h2>';
	if (isset ($_POST['create_booby_admin']))
	{
		createTableBoobyAdmin ();
	}
	if (checkBoobyAdminTable ())
	{
		echo ($state_messages['table_booby_admin_found']);
		if (checkTableBoobyAdmin ())
		{
			step_booby_user_table ();
		}
		else 
		{
			if (isset ($_POST['update_booby_admin']))
			{
				updateTableBoobyAdmin ();
				step_booby_admin_table ();
			}
			else
			{
				echo ($state_messages['booby_admin_not_yet_filled']);
			}
		}
	}
	else
	{
		echo ($state_messages['table_booby_admin_not_found']);
		echo ($state_messages['ask_to_create_booby_admin']);
	}
}

/**********************************************************************************
 *  B O O B Y  -  U S E R S 
 **********************************************************************************/
function createTableBoobyUsers ()
{
	$queries['create_booby_users']="
		create table booby_users (
			userId integer auto_increment not null primary key,
			loginname	char (15) not null,
			password char (50),
			name char (50),
			email char (30),
			description text,
			when_created DATETIME,
			lastLogin DATETIME
		)
	";
	$queries['add_booby_users_admin']="
		insert into booby_users values (0, 'admin', MD5('admin'), 'Booby administrator',null, null, null, null)
	";	
	// directly create (and fill) the preferences as well, we are dealing
	// with a new install 
	$db = getDatabaseConnection ();
	$db->Execute ($queries ['create_booby_users'])
		or die ($db->ErrorMsg ());
	$db->Execute ($queries ['add_booby_users_admin'])
		or die ($db->ErrorMsg ());
	//createNewPreferences ();
	createTable ('booby_user_preferences');
	insertPreference ('admin', 'language', 'EN');
	insertPreference ('admin', 'booby_template', 'mylook');
		
}

function checkOldUser ()
{
	$db = getDatabaseConnection ();
	$columnNames = $db->MetaColumnNames ('booby_users');
	
	return (
		count ($columnNames) == 7 &&
		$columnNames[0] == 'userId' && 
		$columnNames[1] == 'username' &&
		$columnNames[2] == 'password' &&
		$columnNames[3] == 'name' &&
		$columnNames[4] == 'email' &&
		$columnNames[5] == 'description' &&
		$columnNames[6] == 'when_created'
	);
}

function convertOldUser ()
{
	$queries ['convert_user_table1']="
		ALTER TABLE booby_users ADD COLUMN lastLogin DATETIME
	";
	$queries ['convert_user_table2']="
		ALTER TABLE booby_users CHANGE username loginname char(15)
	";
	$db = getDatabaseConnection ();
	
	$query1 = $queries ['convert_user_table1'];
	$db->Execute ($query1) or die ($db->ErrorMsg ());

	$query2 = $queries ['convert_user_table2'];
	$db->Execute ($query2) or die ($db->ErrorMsg ());
}

function checkNewUser ()
{
	$db = getDatabaseConnection ();
	$columnNames = $db->MetaColumnNames ('booby_users');
	
	return (
		count ($columnNames) == 8 &&
		$columnNames[0] == 'userId' && 
		$columnNames[1] == 'loginname' &&
		$columnNames[2] == 'password' &&
		$columnNames[3] == 'name' &&
		$columnNames[4] == 'email' &&
		$columnNames[5] == 'description' &&
		$columnNames[6] == 'when_created' &&
		$columnNames[7] == 'lastLogin'
	);
}

function step_booby_user_table ()
{
	$state_messages['old_installation_detected']='<h3>Old installation detected</h3>
	<p>We will now check the user table and the user preferences table and 
	convert them.</p>';
	$state_messages['convert_booby_users']='We will start by converting the user table. 
	Click ok to continue
	<form method="POST" action="'.$_SERVER['PHP_SELF'].'">
		<input type="hidden" name="convert_old_user" />
		<input type="submit" value="Convert user table" name="convert_old_user" />
	</form>';
	$state_messages['ask_to_create_booby_users']='
	<h2>Create table <code>booby_users</code></h2>
	<p>
		Click the button below to execute the following statement:
		<pre>'.$queries['create_booby_users'].'</pre>
	</p>
	<form method="POST" action="'.$_SERVER['PHP_SELF'].'">
		<input type="submit" value="Create table" name="create_booby_users" />
	</form>';
	$state_messages['table_booby_users_found']="<h2>Table <code>booby_users</code> ok</h2>
	We will now check the preferences, create or possibly convert them.
	";
	
	if (checkOldUser ())
	{
		echo ($state_messages['old_installation_detected']);
		if (isset ($_POST['convert_old_user']))
		{
			convertOldUser ();
			step_booby_user_table ();
		}
		else
		{
			echo ($state_messages['convert_booby_users']);
		}
	}
	else if (checkNewUser ())
	{
		echo ($state_messages['table_booby_users_found']);
		step_booby_preferences_table ();
	}
	else
	{
		if (isset ($_POST['create_booby_users']))
		{
			createTableBoobyUsers ();
			step_booby_user_table ();
		}
		else 
		{
			echo ($state_messages['ask_to_create_booby_users']);
		}
	}
}

/**********************************************************************************
 *  B O O B Y  -  U S E R  P R E F E R E N C E S 
 **********************************************************************************/
function checkOldPreferences ()
{
	$db = getDatabaseConnection ();
	$columnNames = $db->MetaColumnNames ('booby_preferences');
	
	return (
		count ($columnNames) == 3 &&
		$columnNames[0] == 'owner' && 
		$columnNames[1] == 'language' &&
		$columnNames[2] == 'template'
	);
}

/**
 * Obsolete ???
 */
function createNewPreferences ()
{
	createTable ('booby_user_preferences');
	$db = getDatabaseConnection ();
	
	$query = $queries['create_new_preferences'];
	$db->Execute ($query) or die ($db->ErrorMsg ());
}

function convertOldToNewPreferences ()
{
	$queries['get_old_preferences']="
		SELECT * from booby_preferences
	";
	//createNewPreferences ();
	createTable ('booby_user_preferences');
	$db = getDatabaseConnection ();
	
	$query = $queries ['get_old_preferences'];
	$rs = $db->Execute ($query) or die ($db->ErrorMsg ());
	while (!$rs->EOF)
	{
		insertPreference ($rs->fields[0], 'language', $rs->fields[1]);
		insertPreference ($rs->fields[0], 'booby_template', $rs->fields[2]);
		$rs->MoveNext ();
	} 
	dropOldPreferences ();
}

function dropOldPreferences ()
{
	$queries['drop_booby_preferences']="
		DROP TABLE booby_preferences
	";
	$db = getDatabaseConnection ();

	$query = $queries['drop_booby_preferences'];
	$db->Execute ($query) or die ($db->ErrorMsg ());
}

function checkNewPreferences ()
{
	$db = getDatabaseConnection ();
	$columnNames = $db->MetaColumnNames ('booby_user_preferences');
	return (
		count ($columnNames) == 11 &&
		$columnNames[0] == 'itemId' && 
		$columnNames[1] == 'owner' &&
		$columnNames[2] == 'parentId' &&
		$columnNames[3] == 'isParent' &&
		$columnNames[4] == 'name' &&
		$columnNames[5] == 'description' &&
		$columnNames[6] == 'visibility' &&
		$columnNames[7] == 'category' &&
		$columnNames[8] == 'when_created' &&
		$columnNames[9] == 'when_modified' &&
		$columnNames[10] == 'value'
	);
}

function insertPreference ($username, $name, $value)
{
	$queries['insert_preferences']="
		INSERT INTO booby_user_preferences VALUES (0, '%s', 0, 0, '%s', null, 'private', null, null, null, '%s')
	";
	$db = getDatabaseConnection ();
	$db->Execute (sprintf ($queries['insert_preferences'], $username, $name, $value))
		or die ($db->ErrorMsg ());
}

function step_booby_preferences_table ()
{
	$state_messages['update_preferences']='<h2>Old version of the preferences found.</h2> 
		Press ok to convert to a new table insert data from the old table
		<form method="POST" action="'.$_SERVER['PHP_SELF'].'">
			<input type="submit" value="Create table" name="update_preferences" />
		</form>';
	$state_messages['ask_to_create_booby_user_preferences']='
		<h2>Create table <code>booby_user_preferences</code></h2>
		<form method="POST" action="'.$_SERVER['PHP_SELF'].'">
			<input type="submit" value="Create table" name="create_preferences" />
		</form>';
	$state_messages['table_booby_user_preferences_found']='
		<h2>Table <code>booby_user_preferences</code> ok</h2>
	';
	if (checkOldPreferences ())
	{
		if (isset ($_POST['update_preferences']))
		{
			convertOldToNewPreferences ();
			step_booby_preferences_table ();
		}
		else
		{
			echo ($state_messages['update_preferences']);
		}
	}
	else if (checkNewPreferences ())
	{
		echo ($state_messages['table_booby_user_preferences_found']);
		addIndex ('booby_user_preferences');
		//step_booby_bookmarks_table ();
		step_booby_plugin_settings ();
	}
	else
	{
		if (isset ($_POST['create_preferences']))
		{
			createNewPreferences ();
			step_booby_preferences_table ();
		}
		else
		{
			echo ($state_messages['ask_to_create_booby_user_preferences']);
		}
	}
}

/*******************************************************************************
BOOBY PLUGIN SETTINGS
*******************************************************************************/
function activatePlugin ($username, $plugin)
{
	$query = "INSERT INTO booby_plugin_settings VALUES (".
		 "'', '".$username."', 0, 0, '".$plugin."', null, ".
		                 "'private', null, null, null, 'true')";

	$db = getDatabaseConnection ();
	$db->execute ($query) or die ($db->ErrorMsg () . ":".$query);
}
function createNewPluginSettings ()
{
	createTable ('booby_plugin_settings');
	$db = getDatabaseConnection ();
	

	$query = 'select loginname from booby_users';
	$resultSet = $db->Execute ($query) or die ($db->ErrorMsg ().':'.$query);
	while (!$resultSet -> EOF)	
	{
		$current = $resultSet->fields['loginname'];
		activatePlugin ($current, 'bookmarks');
		activatePlugin ($current, 'contacts');
		activatePlugin ($current, 'news');
		activatePlugin ($current, 'notes');
		activatePlugin ($current, 'todos');
		$resultSet->MoveNext ();
	}
}

function checkNewPluginSettings ()
{
	$db = getDatabaseConnection ();
	$columnNames = $db->MetaColumnNames ('booby_plugin_settings');
	return (
		count ($columnNames) == 11 &&
		$columnNames[0] == 'itemId' && 
		$columnNames[1] == 'owner' &&
		$columnNames[2] == 'parentId' &&
		$columnNames[3] == 'isParent' &&
		$columnNames[4] == 'name' &&
		$columnNames[5] == 'description' &&
		$columnNames[6] == 'visibility' &&
		$columnNames[7] == 'category' &&
		$columnNames[8] == 'when_created' &&
		$columnNames[9] == 'when_modified' &&
		$columnNames[10] == 'value'
	);
}

function step_booby_plugin_settings ()
{
	$state_messages['ask_to_create_booby_plugin_settings']='
		<h2>Create table <code>booby_plugin_settings</code></h2>
		<form method="POST" action="'.$_SERVER['PHP_SELF'].'">
			<input type="submit" value="Create table" name="create_plugin_settings" />
		</form>';
	$state_messages['table_booby_plugin_settings_found']='
		<h2>Table <code>booby_plugin_settings</code> ok</h2>
	';
	if (checkNewPluginSettings ())
	{
		echo ($state_messages['table_booby_plugin_settings_found']);
		addIndex ('booby_user_plugin_settings');
		step_booby_bookmarks_table ();
	}
	else
	{
		if (isset ($_POST['create_plugin_settings']))
		{
			createNewPluginSettings ();
			step_booby_plugin_settings ();
		}
		else
		{
			echo ($state_messages['ask_to_create_booby_plugin_settings']);
		}
	}
}

/**********************************************************************************
 *  B O O B Y  -  B O O K M A R K S 
 **********************************************************************************/
function checkBookmarks ()
{
	$db = getDatabaseConnection ();
	$columnNames = $db->MetaColumnNames ('booby_bookmarks');
	
	return (
		count ($columnNames) == 13 &&
		$columnNames[0] == 'itemId' && 
		$columnNames[1] == 'owner' &&
		$columnNames[2] == 'parentId' &&
		$columnNames[3] == 'isParent' &&
		$columnNames[4] == 'name' &&
		$columnNames[5] == 'description' &&
		$columnNames[6] == 'visibility' &&
		$columnNames[7] == 'category' &&
		$columnNames[8] == 'when_created' &&
		$columnNames[9] == 'when_modified' &&
		$columnNames[10] == 'when_visited' &&
		$columnNames[11] == 'locator' &&
		$columnNames[12] == 'visitCount'
	);
}

function checkBookmarksVersion ()
{
	$db = getDatabaseConnection ();
	$metaColumns = $db->MetaColumns ('booby_bookmarks');
	$locatorColumn = $metaColumns['LOCATOR'];
	$type = $locatorColumn->type;
	if ($type == 'varchar')
	{
		return false;
	}
	else
	{
		return true;
	}
}

function upgradeBookmarksVersion ()
{
	$db = getDatabaseConnection ();
	$query = "ALTER TABLE booby_bookmarks CHANGE `locator` `locator` TEXT DEFAULT null";
	$db->Execute ($query) or die ($db->ErrorMsg ());
}

function step_booby_bookmarks_table ()
{
	$state_messages['ask_to_upgrade_booby_bookmarks']='
		<h2>Upgrade <code>booby_bookmarks</code></h2>
		<p>
			The field link will be upgraded from
			<code>char (70)</code> to <code>text</code>
		</p>
		<form method="POST" action="'.$_SERVER['PHP_SELF'].'">
			<input type="submit" value="Upgrade table" name="upgrade_booby_bookmarks" />
		</form>';
	$state_messages['ask_to_create_booby_bookmarks']='
		<h2>Create table <code>booby_bookmarks</code></h2>
		<form method="POST" action="'.$_SERVER['PHP_SELF'].'">
			<input type="submit" value="Create table" name="create_booby_bookmarks" />
		</form>';
	$state_messages['table_booby_bookmarks_found']='
			<h2>Table <code>booby_bookmarks</code> ok</h2>
	';
	if (checkBookmarks ())
	{
		if (checkBookmarksVersion ())
		{
			echo ($state_messages['table_booby_bookmarks_found']);
			step_booby_contacts_table ();
		}
		else
		{
			if (isset ($_POST['upgrade_booby_bookmarks']))
			{
				upgradeBookmarksVersion ();
				step_booby_bookmarks_table ();
			}
			else
			{
				echo ($state_messages['ask_to_upgrade_booby_bookmarks']);
			}
		}
	}
	else
	{
		if (isset ($_POST['create_booby_bookmarks']))
		{
			createTable ('booby_bookmarks');
			step_booby_bookmarks_table ();
		}
		else
		{
			echo ($state_messages['ask_to_create_booby_bookmarks']);
		}
	}
}

/**********************************************************************************
 *  B O O B Y  -  C O N T A C T S 
 **********************************************************************************/
function checkContacts ()
{
	$db = getDatabaseConnection ();
	$columnNames = $db->MetaColumnNames ('booby_contacts');
	
	return (
		count ($columnNames) == 26 &&
		$columnNames[0] == 'itemId' && 
		$columnNames[1] == 'owner' &&
		$columnNames[2] == 'parentId' &&
		$columnNames[3] == 'isParent' &&
		$columnNames[4] == 'name' &&
		$columnNames[5] == 'description' &&
		$columnNames[6] == 'visibility' &&
		$columnNames[7] == 'category' &&
		$columnNames[8] == 'when_created' &&
		$columnNames[9] == 'when_modified' &&
		$columnNames[10] == 'alias' &&
		$columnNames[11] == 'address' &&
		$columnNames[12] == 'birthday' &&
		$columnNames[13] == 'mobile' &&
		$columnNames[14] == 'faximile' &&
		$columnNames[15] == 'tel_home' &&
		$columnNames[16] == 'tel_work' &&
		$columnNames[17] == 'organization' &&
		$columnNames[18] == 'org_address' &&
		$columnNames[19] == 'job' &&
		$columnNames[20] == 'email1' &&
		$columnNames[21] == 'email2' &&
		$columnNames[22] == 'email3' &&
		$columnNames[23] == 'webaddress1' &&
		$columnNames[24] == 'webaddress2' &&
		$columnNames[25] == 'webaddress3' 
	);
}


function step_booby_contacts_table ()
{
	$state_messages['ask_to_create_booby_contacts']='
		<h2>Create table <code>booby_contacts</code></h2>
		<form method="POST" action="'.$_SERVER['PHP_SELF'].'">
			<input type="submit" value="Create table" name="create_booby_contacts" />
		</form>';
	$state_messages['table_booby_contacts_found']='
		<h2>Table <code>booby_contacts</code> ok</h2>
	';
	if (checkContacts ())
	{
		echo ($state_messages['table_booby_contacts_found']);
		step_booby_news_table ();
	}
	else
	{
		if (isset ($_POST['create_booby_contacts']))
		{
			createTable ('booby_contacts');
			step_booby_contacts_table ();
		}
		else
		{
			echo ($state_messages['ask_to_create_booby_contacts']);
		}
	}
}

/**********************************************************************************
 *  B O O B Y  -  N E W S 
 **********************************************************************************/
function checkNews ()
{
	$db = getDatabaseConnection ();
	$columnNames = $db->MetaColumnNames ('booby_news');
	
	return (
		count ($columnNames) == 13 &&
		$columnNames[0] == 'itemId' && 
		$columnNames[1] == 'owner' &&
		$columnNames[2] == 'parentId' &&
		$columnNames[3] == 'isParent' &&
		$columnNames[4] == 'name' &&
		$columnNames[5] == 'description' &&
		$columnNames[6] == 'visibility' &&
		$columnNames[7] == 'category' &&
		$columnNames[8] == 'when_created' &&
		$columnNames[9] == 'when_modified' &&
		$columnNames[10] == 'when_visited' &&
		$columnNames[11] == 'locator' &&
		$columnNames[12] == 'visitCount'
	);
}

function step_booby_news_table ()
{
	$state_messages['ask_to_create_booby_news']='
		<h2>Create table <code>booby_news</code></h2>
		<form method="POST" action="'.$_SERVER['PHP_SELF'].'">
			<input type="submit" value="Create table" name="create_booby_news" />
		</form>';
	$state_messages['table_booby_news_found']='
		<h2>Table <code>booby_news</code> ok</h2>
	';
	if (checkNews ())
	{
		echo ($state_messages['table_booby_news_found']);
		step_booby_notes_table ();
	}
	else
	{
		if (isset ($_POST['create_booby_news']))
		{
			createTable ('booby_news');
			step_booby_news_table ();
		}
		else
		{
			echo ($state_messages['ask_to_create_booby_news']);
		}
	}
}

/**********************************************************************************
 *  B O O B Y  -  N O T E S 
 **********************************************************************************/
function checkNotes ()
{
	$db = getDatabaseConnection ();
	$columnNames = $db->MetaColumnNames ('booby_notes');
	
	return (
		count ($columnNames) == 10 &&
		$columnNames[0] == 'itemId' && 
		$columnNames[1] == 'owner' &&
		$columnNames[2] == 'parentId' &&
		$columnNames[3] == 'isParent' &&
		$columnNames[4] == 'name' &&
		$columnNames[5] == 'description' &&
		$columnNames[6] == 'visibility' &&
		$columnNames[7] == 'category' &&
		$columnNames[8] == 'when_created' &&
		$columnNames[9] == 'when_modified' 
	);
}

function step_booby_notes_table ()
{
	$state_messages['ask_to_create_booby_notes']='
	<h2>Create table <code>booby_notes</code></h2>
	<form method="POST" action="'.$_SERVER['PHP_SELF'].'">
		<input type="submit" value="Create table" name="create_booby_notes" />
	</form>';
	$state_messages['table_booby_notes_found']='
		<h2>Table <code>booby_notes</code> ok</h2>
	';
	if (checkNotes ())
	{
		echo ($state_messages['table_booby_notes_found']);
		step_booby_todos_table ();
	}
	else
	{
		if (isset ($_POST['create_booby_notes']))
		{
			createTable ('booby_notes');
			step_booby_notes_table ();
		}
		else
		{
			echo ($state_messages['ask_to_create_booby_notes']);
		}
	}
}

/**********************************************************************************
 *  B O O B Y  -  T O D O S 
 **********************************************************************************/
function checkTodos ()
{
	$db = getDatabaseConnection ();
	$columnNames = $db->MetaColumnNames ('booby_todos');
	
	return (
		count ($columnNames) == 16 &&
		$columnNames[0] == 'itemId' && 
		$columnNames[1] == 'owner' &&
		$columnNames[2] == 'parentId' &&
		$columnNames[3] == 'isParent' &&
		$columnNames[4] == 'name' &&
		$columnNames[5] == 'description' &&
		$columnNames[6] == 'visibility' &&
		$columnNames[7] == 'category' &&
		$columnNames[8] == 'when_created' &&
		$columnNames[9] == 'when_modified' &&
		$columnNames[10] == 'priority' &&
		$columnNames[11] == 'startDate' &&
		$columnNames[12] == 'endDate' &&
		$columnNames[13] == 'status' &&
		$columnNames[14] == 'percentComplete' &&
		$columnNames[15] == 'isFinished'
	);
}

function step_booby_todos_table ()
{
	$state_messages['ask_to_create_booby_todos']='
	<h2>Create table <code>booby_todos</code></h2>
	<form method="POST" action="'.$_SERVER['PHP_SELF'].'">
		<input type="submit" value="Create table" name="create_booby_todos" />
	</form>';
	$state_messages['table_booby_todos_found']='
		<h2>Table <code>booby_todos</code> ok</h2>
	';
	
	
	if (checkTodos ())
	{
		echo ($state_messages['table_booby_todos_found']);
		final ();
	}
	else
	{
		if (isset ($_POST['create_booby_todos']))
		{
			createTable ('booby_todos');
			step_booby_todos_table ();
		}
		else
		{
			echo ($state_messages['ask_to_create_booby_todos']);
		}
	}
}

/**********************************************************************************
 *  S T A R T / S T O P  B O O B Y   I N S T A L L A T I O N 
 **********************************************************************************/
function start ()
{
	step_check_adodb ();
}
function final ()
{
		$queries['getInstallationPath']="
			SELECT value FROM booby_admin WHERE name='installation_path'
		";
		$db = getDatabaseConnection ();
		$result = $db->Execute ($queries['getInstallationPath']);
		
		$state_messages['installation_complete']='<h1>Installation complete</h1>
			<p>
				Click <a href="'.$result->fields[0].'">here</a> to go to the installation
			</p>
			<p>
				<font color="red">DON\'T forget to change the admin password!!!!!</font>
			</p>
			<p>If this specific link fails, you probably have an error in your server path. click 
				<a href="index.php">here</a> to continue, log in as administrator and go to the 
				configuration section to set the appropriate path (your quickmarks will not work 
				if you ignore this step)
			</p>';
		
		$oldVersion = getInstalledBoobyVersion ();
		//$query = "SELECT * FROM booby_admin WHERE name='booby_version'";
		//$rs = $db->Execute ($query) or die ($db->ErrorMsg());
		//$result = $rs->FetchRow();
		//$oldVersion = $result['value'];
		if ($oldVersion != NEWVERSION)
		{
			echo ('Found version: '.$oldVersion.'<br />');
			echo ('Updating version number to '.NEWVERSION);
			$query = "UPDATE booby_admin SET value='".NEWVERSION."' WHERE name='booby_version'";
			$db->Execute ($query) or die ($db->ErrorMsg());
		}
		echo ($state_messages['installation_complete']);
		
}
?>


<html>
<head>
	<title>Booby - installation</title>
	<link rel="stylesheet" href="doc/css/booby.css" type="text/css" />
</head>

<body>
<h1>Booby installation</h1>
<p>
	Welcome to the Booby installation/update script. Note that this script will fail if you're installing
	from a Booby version before version 0.2.0!!! Continue at your own risk.
</p>
<p>
	<font color="red">
		 If you UPGRADE the application, please make a database 
		 backup before continuing!!!
		 <br />
		 Remove this script if the installation was succesful!
		 <br />
		 When you upgrade from a 0.3.0 release candidate version
		 please delete the following tables:
		 <ul>
		 	<li>booby_admin</li>
		</ul>
	</font>
</p>
<?php
	start ();
?>		
</body>
</html>
