<?php
/**
 * vim: set number : 
 * vim: set tabstop=4 :
 *
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 * @package be.nauta.booby.base.view
 * @author Barry Nauta 
 * @copyright Barry Nauta	
 */
include ('base/lang/dictionary_EN.php');
include ('base/config/databaseConfiguration.php');
if (isset ($_SESSION['language']))
{
	if (file_exists ('base/lang/dictionary_' . $_SESSION['language'] . '.php'))
	{
		include  ('base/lang/dictionary_' . $_SESSION['language'] . '.php');
	}
}
/*
 * The current defined items
 */
 /*
$menuItems = array();
$menuItems [] =	
		array('href' => 'BookmarkController.php',
			'name' => $dictionary['bookmarks'],
			'icon' => 'bookmarks');

$menuItems [] =	
		array('href' => 'ContactController.php',
			'name' => $dictionary['contacts'],
			'icon' => 'contacts');
$menuItems [] =	
		array('href' => 'TodoController.php',
			'name' => $dictionary['todos'],
			'icon' => 'todos');
$menuItems [] =	
		array('href' => 'NoteController.php',
			'name' => $dictionary['notes'],
			'icon' => 'notes');
if (function_exists('xml_parser_create'))
{ 
	// only include the news section if we have XML parsing enabled
	// in PHP
	$menuItems [] =	
		array('href' => 'NewsController.php',
			'name' => $dictionary['news'],
			'icon' => 'news');
}	
*/
/*
 * The application specific breadcrumbs
 */
$menu = array();
$menu [] =
	array('href' => 'PreferenceController.php',
			'name' => $dictionary['preferences'],
			'icon' => 'preferences');
$menu [] =
	array('href' => 'about.php',
			'name' => $dictionary['about'],
			'icon' => 'info');
$menu [] =
	array('href' => 'logout.php',
			'name' => $dictionary['logout'],
			'icon' => 'logout');
$menu [] =
	array('href' => 'PluginController.php',
			'name' => $dictionary['plugins'],
			'icon' => 'plugins');
// only provide the admin page if we are the admin user
if ($_SESSION['boobyUsername'] == 'admin')
{
	$menu [] = array('href' => 'admin.php',
			'name' => $dictionary['admin'],
			'icon' => 'Admin');
	$menu [] = array('href' => 'admin.php?action=modifyAdminConfigPre',
			'name' => $dictionary['adminConfig'],
			'icon' => 'AdminConfig');
	$menu [] = array('href' => 'sysinfo.php',
			'name' => $dictionary['sysinfo'],
			'icon' => 'SysInfo');
}


require_once ('base/model/PluginServices.php');
$services = new PluginServices ();
$plugins=$services->getPlugins ();
$pluginSettings = $services->getPluginSettingsAsArray 
	($_SESSION['boobyUsername']);
$menuItems = array ();
foreach ($plugins as $plugin)
{
	$pluginName = $plugin['name'];
	if (isset ($pluginSettings[$pluginName])
		&& $pluginSettings[$pluginName] == 'true')
	{
		$menuItems [] =
			array('href' => $plugin['controller'],
				'name' =>  $dictionary[$pluginName],
				'icon' => $pluginName);
	}
}
?>
