<?php
/*
 * vim: set number :
 * vim: set tabstop=4 :
 *
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('base/model/ItemFactory.php');
require_once ('plugins/calendar/model/Event.php');
require_class('RequestCast', 'base/util/request/RequestCast.class.php'); // Michael
require_class('ClassHelper', 'base/util/ClassHelper.class.php'); // Michael
/**
 * CalendarFactory
 *
 * @author Barry Nauta June 2004
 * @package be.nauta.booby.plugins.bookmarks.model
 * @copyright
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code>
 * and look for licenses
 */
class CalendarFactory extends ItemFactory
{
		/**
		 * Default constructor
		 */
		function CalendarFactory ()
		{
			parent::ItemFactory ();
		}

		/**
		 * Returns the type of this specific item
		 * @return string the type of this specific item: 
		 * <code>Event</code>
		 */
		function getType ()
		{
			return "Event";
		}

		/**
		 * Factory method. Return an HTTP request into an item by 
		 * fecthing the appropriate parameters from the POST request
		 * 
		 * @return object the item constructed from the POST request
		 * @uses the POST request
		 */
		function requestToItem ()
		{
			$itemId = $this->getFromPost ('itemId', 0);
			$parentId = $this->getFromPost ('parentId', 0);
			$isParent = $this->getFromPost ('isParent', 0);
			$name = $this->getFromPost ('name', null);
			$when_created = $this->getFromPost ('when_created', null);
			$when_modified = $this->getFromPost ('when_modified', null);
			$visibility = $this->getFromPost ('visibility', 'private');
			$category = $this->getFromPost ('category', null);
			$description = $this->getFromPost ('description', null);
			$location = $this->getFromPost ('location', null);

			$eventStartDateYear = $_POST['start_year'];
			$eventStartDateMonth = $_POST['start_month'];
			$eventStartDateDay = $_POST['start_day'];
			$eventStartTimeHour = $_POST['start_time_hours'];
			$eventStartTimeMinutes = $_POST['start_time_minutes'];

			$eventStartDate = mktime (
				$eventStartTimeHour,
				$eventStartTimeMinutes,
				0,
				$eventStartDateMonth, 
				$eventStartDateDay,
				$eventStartDateYear);

			$eventEndDateYear = $_POST['end_year'];
			$eventEndDateMonth = $_POST['end_month'];
			$eventEndDateDay = $_POST['end_day'];
			$eventEndTimeHour = $_POST['end_time_hours'];
			$eventEndTimeMinutes = $_POST['end_time_minutes'];

			$eventEndDate = mktime (
				$eventEndTimeHour,
				$eventEndTimeMinutes,
				0,
				$eventEndDateMonth, 
				$eventEndDateDay,
				$eventEndDateYear);

			$item = new Event
			(
					$itemId,
					$_SESSION['boobyUsername'],
					$parentId,
					$isParent,
					$name,
					$description,
					$visibility,
					$category,
					$when_created,
					$when_modified,
					$location,
					$eventStartDate,
					$eventEndDate
			);
			
			return $item;
		}
}
?>
