<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('base/model/Item.php');
/**
 * The Event item.
 *
 * @author Barry Nauta June 2004
 * @package be.nauta.booby.plugins.calendar.model
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta 
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code>
 * and look for licenses
 */
class Event extends Item
{
	var $location;
	var $eventStartDate;
	var $eventEndDate;

	/**
	 * Full-blown Constructor.
	 * 
	 * @param integer theItemId the id of the item
	 * @param string theOwner who owns this item?
	 * @param integer theParentId what is the id of the parent of this item?
	 * @param boolean parent is this a parent (true) or child (false)
	 * @param string theName the name of this item
	 * @param string theDescription the description of this item
	 * @param string theVisibility the visibility (private or public)
	 * @param string theCategory what is the category of this item?
	 * @param string created When was this item created?
	 * @param string modified When was this item modified?
	 * @param string location
	 * @param date eventStartDate
	 * @param date eventEndDate
	 */
	function Event (
		$theItemId, $theOwner, $theParentId, $parent,$theName,
		$theDescription, $theVisibility, $theCategory,
		$created, $modified, $theLocation, 
		$theStartDate, $theEndDate)
	{
		parent :: Item (
				$theItemId, 
				$theOwner, 
				$theParentId, 
				$parent,
				$theName, 
				$theDescription, 
				$theVisibility,
				$theCategory, 
				$created, 
				$modified);

		$this->type = "Event";
		$this->location = $theLocation;
		$this->eventStartDate = $theStartDate;
		$this->eventEndDate = $theEndDate;
	}
	
	/**
	 * Checks whether the constructed item is a valid item (has all the
	 * required fields)
	 *
	 * @return boolean <code>true</code> if the item is valid, <code>false</code> otherwise
	 */	
	function isValid ()
	{
		if (!$this->isParent ())
		{
			return (parent::isValid () && 
				$this->startDate != null &&
				$this->endDate != null);
		}
		return parent::isValid ();
	}
}
?>
