<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('base/model/Item.php');
/**
 * A contact item
 * 
 * @author Barry Nauta March 2003
 * @package be.nauta.booby.plugins.contacts.model
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta 
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code> 
 * and look for licenses
 */
class Contact extends Item
{
	/**
	 * The alias for the contact
	 * @access private
	 * @var string 
	 */
	var $alias;
	
	/**
	 * The address of the contact
	 * @access private
	 * @var string 
	 */
	var $address;
	
	/**
	 * The birthday of the contact (not used yet)
	 * @access private
	 * @var string
	 */
	var $birthday;
	
	/**
	 * The mobile telephone number (GSM) of the contact
	 * @access private
	 * @var string 
	 */
	var $mobile;
	
	/**
	 * The fax number of the contact
	 * @access private
	 * @var string 
	 */
	var $faximile;
	
	/**
	 * Telephone number at work of the contact
	 * @access private
	 * @var string 
	 */
	var $tel_work;

	/**
	 * Telephone number at home of the contact
	 * @access private
	 * @var string 
	 */
	var $tel_home;
	
	/**
	 * The organization for which the contacts works
	 * @access private
	 * @var string
	 */
	var $organization;
	
	/**
	 * The address of the organization for which the contact works
	 * @access private
	 * @var string 
	 */
	var $org_address;
	
	/**
	 * The contacts jobtitle
	 * @access private
	 * @var string 
	 */
	var $job;

	/**
	 * The first email address of the contact
	 * @access private
	 * @var string 
	 */
	var $email1;
	
	/**
	 * The second email address of the contact
	 * @access private
	 * @var string 
	 */
	var $email2;
	
	/**
	 * The third email address of the contact
	 * @access private
	 * @var string 
	 */
	var $email3;
	
	/**
	 * The first webaddress of the contact
	 * @access private
	 * @var string 
	 */
	var $webaddress1;
	
	/**
	 * The 2nd webaddress of the contact
	 * @access private
	 * @var string 
	 */
	var $webaddress2;

	/**
	 * The 3rd webaddress of the contact
	 * @access private
	 * @var string 
	 */
	var $webaddress3;

	/**
	 * Full blown constructor with all parameters
	 *
	 * @param integer theItemId the id of the item
	 * @param string theOwner who owns this item?
	 * @param integer theParentId what is the id of the parent of this item?
	 * @param boolean parent is this a parent (true) or child (false)
	 * @param string theName the name of this item
	 * @param string theDescription the description of this item
	 * @param string theVisibility the visibility (private or public)
	 * @param string theCategory what is the category of this item?
	 * @param string created When was this item created?
	 * @param string modified When was this item modified?
	 * @param string theAlias the alias of this contact
	 * @param string theAddress The address of the contact
	 * @param string theBirthday The birthday of the contact
	 * @param string theMobile mobile telephone number (GSM) of the contact
	 * @param string theFax the fax number of the contact
	 * @param string theTelHome Telephone number at home of the contact
	 * @param string theTelWork Telephone number at work of the contact
	 * @param string theOrganization organization for which the contacts works
	 * @param string theOrganizationalAddress address of the organization for 
	 *			which the contact works
	 * @param string theJobTitle The contacts jobtitle
	 * @param string theEmail1 first email address of the contact
	 * @param string theEmail2 second email address of the contact
	 * @param string theEmail3 third email address of the contact
	 * @param string theWebAddress1 first webaddress
	 * @param string theWebAddress2 second webaddress
	 * @param string theWebAddress3 third webaddress
	 */
	function Contact ($theItemId, $theOwner, $theParentId,
		$parent, $theName, $theDescription, $theVisibility,
		$theCategory, $theCreation, $theModified, 
		$theAlias,
		$theAddress, $theBirthday, $theMobile, $theFax, 
		$theTelHome, $theTelWork, 
		$theOrganization, $theOrganizationalAddress,
		$theJobTitle, 
		$theEmail1, $theEmail2, $theEmail3,
		$theWebaddress1, $theWebaddress2, $theWebaddress3)
	{
		parent :: Item ($theItemId, $theOwner, $theParentId, $parent,
				$theName, $theDescription, $theVisibility,
				$theCategory, $theCreation, $theModified);
		
		$this->type="Contact";
		$this->job=$theJobTitle;
		$this->tel_home=$theTelHome;
		$this->tel_work=$theTelWork;
		$this->mobile=$theMobile;
		$this->faximile=$theFax;
		$this->address=$theAddress;
		$this->organization=$theOrganization;
		$this->org_address=$theOrganizationalAddress;
		$this->birthday=$theBirthday;
		$this->alias=$theAlias;
		$this->email1=$theEmail1;
		$this->email2=$theEmail2;
		$this->email3=$theEmail3;
		$this->webaddress1=$theWebaddress1;
		$this->webaddress2=$theWebaddress2;
		$this->webaddress3=$theWebaddress3;
	}
}
?>
