<?php
/**
 * The template file to show contacts, instantiates a proper tree-delegate and tree renderer
 * 
 * @package be.nauta.booby.plugins.contacts.view
 * @author Barry Nauta
 * @copyright Barry Nauta
 * 
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: <code>http://www.gnu.org</code> and look for licenses
 *
 * Enjoy :-)
 */

	/*
	 * Show the ancestor path. Contributed by Michael
	 */
	if(isset($parameters['ancestors']) && $parentId != 0)
	{
		echo ('<!-- Ancestors -->');
		echo ('<table><tr>');
		
		// The root link
		echo ('<td><a href="?parentId=0" class="ancestor">'.$dictionary['root'].'</a></td>');

		// all ancestors other than root
		foreach($parameters['ancestors'] as $ancestor)
		{ 
			echo ('<td>&nbsp;/&nbsp;');
			echo ('<a href="?parentId='.$ancestor->itemId.'" class="ancestor">');
			echo ($ancestor->name);
			echo ('</a>');
			echo ('</td>');
		}
		echo ('</tr></table>');
	}		

	include ('templates/'.$_SESSION['booby_template'].'/icons.inc');
	$configuration = array ();
	/*
	 * Build up a proper configuration for the tree display.
	 */
	$configuration['icons']=$icons;
	$configuration['dictionary']=$dictionary;
	$configuration['callback']='ContactController.php';
	
	/*
	 * Check for conditional overlib
	 */
	if (isset ($_SESSION['contactOverlib']))
	{
		$configuration ['overlib'] =$_SESSION['contactOverlib'];
	}
	else
	{
		$configuration ['overlib'] = true;
	}
	/*
	 * Explorer like tree
	 */
	if (isset ($_SESSION['contactTree']) && $_SESSION['contactTree'] == 'Explorer')
	{
			include_once "base/view/Tree.php";
			include_once "plugins/contacts/view/ContactExplorerTreeDelegate.php";
			$delegate = new ContactExplorerTreeDelegate	($configuration);
			$tree = new Tree ($delegate, $configuration);
			/*
			 * Do we show expanded items? (This is not a useful option in the yahoo tree)
			 */
			if (isset ($_SESSION['contactExpand']))
			{
				$tree -> setExpanded ($_SESSION['contactExpand']);
			}
	}
	/*
	 * Yahoo like tree
	 */
	else if (isset ($_SESSION['contactTree']) && $_SESSION['contactTree'] == 'Yahoo')
	{
		/*
		 * Build up a proper configuration for the tree display, this makes only sense for
		 * the yahoo-like tree
		 */
		if (isset ($_SESSION['contactYahooTreeColumnCount']))
		{
			$configuration ['numberOfColumns'] =$_SESSION['contactYahooTreeColumnCount'];
		}
		else
		{
			$configuration ['numberOfColumns'] = 2;
		}
		
		include_once "base/view/YahooTree.php";
		include_once "plugins/contacts/view/ContactYahooTreeDelegate.php";
		$delegate = new ContactYahooTreeDelegate ($configuration);
		$tree = new YahooTree ($delegate, $configuration);
	}
	/*
	 * Line based view
	 */
	else
	{
			include_once "base/view/LineBasedTree.php";
			include_once "plugins/contacts/view/ContactLineBasedTreeDelegate.php";
			$delegate = new ContactLineBasedTreeDelegate	($configuration);
			$tree = new LineBasedTree ($delegate, $configuration);
	}
	/*
	 * Now actually show the layout
	 */
	echo ($tree -> toHtml ($parent, $renderObjects));
?>
