<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is release under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('base/model/ItemFactory.php');
require_once ('plugins/genealogy/model/Person.php');
/**
 * PersonFactory
 *
 * @author Barry Nauta
 * @date January 2004
 * @package be.nauta.booby.plugins.genealogy.model
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta <br />
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code> 
 * and look for licenses
 */
class PersonFactory extends ItemFactory
{
		/**
		 * Default constructor
		 */
		function PersonFactory ()
		{
			parent::ItemFactory ();
		}
	
				
		/**
		 * Factory method: Returns a database result into an item
		 *
		 * @param object result the result retrieved from the database
		 * @return array the items constructed from the database resultset
		 */
		function resultsetToItems ($result)
		{
			$items = array ();
			while (!$result -> EOF)
			{
				$item = new Person 
				(
					$result->fields['itemId'],
					$result->fields['owner'],
					$result->fields['parentId'],
					$result->fields['isParent'], 
					$result->fields['name'],
					$result->fields['description'],
					$result->fields['visibility'],
					$result->fields['category'],
					$result->fields['when_created'],
					$result->fields['when_modified'],
					$result->fields['parentId1'],
					$result->fields['parentId2'],
					$result->fields['firstName'],
					$result->fields['surName'],
					$result->fields['surNamePrefix'],
					$result->fields['title'],
					$result->fields['alias'],
					$result->fields['gender'],
					$result->fields['birthDayInMonth'],
					$result->fields['birthMonth'],
					$result->fields['birthYear'],
					$result->fields['birthPlace'],
					$result->fields['deathDayInMonth'],
					$result->fields['deathMonth'],
					$result->fields['deathYear'],
					$result->fields['deathPlace'],
					$result->fields['imageURL']
				);
				$items [] = $item;
				$result->MoveNext ();
			}
			return $items;
		}
		
		
		/**
		 * Factory method. Return an HTTP request into an item by 
		 * fecthing the appropriate parameters from the POST request
		 *
		 * @return object the item constructed from the POST request
		 * @uses the POST request
		 */
		function requestToItem ()
		{
			$visibility = $this->getFromPost ('visibility', 'private');
			$parentId = $this->getFromPost ('parentId', 0);
			$isParent = $this->getFromPost ('isParent', 0);
			$when_created = $this->getFromPost ('when_created', null);
			$when_modified = $this->getFromPost ('when_modified', null);
			$itemId = $this->getFromPost ('itemId', 0);
			$category = $this->getFromPost ('category', null);
	
			$parentId1=$this->getFromPost ('parentId1', 0);		
			$parentId2=$this->getFromPost ('parentId2', 0);		
			$firstName = $this->getFromPost ('firstName', null);
			$surName = $this->getFromPost ('surName', null);
			$surNamePrefix = $this->getFromPost ('surNamePrefix', null);
			$title = $this->getFromPost ('title', null);
			$alias = $this->getFromPost ('alias', null);
			$gender = $this->getFromPost ('gender', 'U');
			$birthDayInMonth = $this->getFromPost ('birthDayInMonth', 0);
			$birthMonth = $this->getFromPost ('birthMonth', 0);
			$birthYear = $this->getFromPost ('birthYear', 0);
			$birthPlace = $this->getFromPost ('birthPlace', null);
			$deathDayInMonth = $this->getFromPost ('deathDayInMonth', 0);
			$deathMonth = $this->getFromPost ('deathMonth', 0);
			$deathYear = $this->getFromPost ('deathYear', 0);
			$deathPlace = $this->getFromPost ('deathPlace', null);		
			$imageURL = $this->getFromPost ('imageURL', null);
			$name = $this->getFromPost ('name', null);
			$description = $this->getFromPost ('description', null);

			$item = new Person (
				$itemId,
				$_SESSION['boobyUsername'],
				$parentId,
				$isParent,
				$name,
				$description,
				$visibility,
				$category,
				$when_created,
				$when_modified,
				$parentId1,
				$parentId2,
				$firstName,
				$surName,
				$surNamePrefix,
				$title,
				$alias,
				$gender,
				$birthDayInMonth,
				$birthMonth,
				$birthYear,
				$birthPlace,
				$deathDayInMonth,
				$deathMonth,
				$deathYear,
				$deathPlace,
				$imageURL
			);
			return $item;
		}
				
}
?>
