<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is release under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('base/util/StringUtils.php');
require_once ('base/model/Item.php');
/**
 * A relationship
 *
 * @author Barry Nauta
 * @date January 2004
 * @package be.nauta.booby.plugins.genealogy.model
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta <br />
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code> 
 * and look for licenses
 */
class RelationShip extends Item
{
	var $person1;
	var $person2;
	var $theType;
	var $startDate;
	var $endDate;
	var $location;
	var $imageURL;

	var $information;

	var $firstPerson;
	var $secondPerson; 
	/**
 	 * Full blown constructor
	 *
	 * @param integer theItemId the itemId
	 * @param string theOwner the owner
	 * @param integer theParentId the identifier of the parent
	 * @param boolean parent is this a parent yes or no?
	 * @param string theName the name of this item
	 * @param string theDescription the decription
	 * @param string theVisibility private or public
	 * @param string theCategory the category
	 * @param string theCreation when was this item created?
	 * @param string theModified when was this item last modified?
	 */
	function RelationShip ($theItemId, $theOwner, $theParentId, $parent,
		$theName, $theDescription,
		$theVisibility, $theCategory, $theCreation, $theModified,
				$theFirstPerson, $theSecondPerson,
				$type, $theStartDate, $theEndDate, $theLocation,$theImageURL)
	{
		parent :: Item ($theItemId, $theOwner, $theParentId, $parent,
				$theName, $theDescription, $theVisibility,
				$theCategory, $theCreation, $theModified
		);
		$this->type="RelationShip";
		$this->person1=$theFirstPerson;
		$this->person2=$theSecondPerson;
		$this->theType=$type;
		$this->startDate=$theStartDate;
		$this->endDate=$theEndDate;
		$this->location=$theLocation;
		$this->imageURL=$theImageURL;
		
		$this->information = array ();
	}
	
	function addInformation ($theInformationItem)
	{
		$this->information [] = $theInformationItem;
	}

	
}
?>
