<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is release under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('base/model/ItemFactory.php');
require_once ('plugins/genealogy/model/RelationShip.php');
/**
 * RelationShipFactory
 *
 * @author Barry Nauta
 * @date January 2004
 * @package be.nauta.booby.plugins.genealogy.model
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta <br />
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</a> 
 * and look for licenses
 */
class RelationShipFactory  extends ItemFactory
{
		/**
		 * Default constructor
		 */
		function RelationShipFactory ()
		{
			parent::ItemFactory ();
		}
	
				
		/**
		 * Factory method: Returns a database result into an item
		 *
		 * @param object result the result retrieved from the database
		 * @return array the items constructed from the database resultset
		 */
		function resultsetToItems ($result)
		{
			$items = array ();
			while (!$result -> EOF)
			{
				$item = new RelationShip 
				(
					$result->fields['itemId'],
					$result->fields['owner'],
					$result->fields['parentId'],
					$result->fields['isParent'], 
					$result->fields['name'],
					$result->fields['description'],
					$result->fields['visibility'],
					$result->fields['category'],
					$result->fields['when_created'],
					$result->fields['when_modified'],
					$result->fields['person1'],
					$result->fields['person2'],
					$result->fields['theType'],
					$result->fields['startDate'],
					$result->fields['endDate'],
					$result->fields['location'],
					$result->fields['imageURL']
				);
				$items [] = $item;
				$result->MoveNext ();
			}
			return $items;
		}
		
		/**
		 * Factory method. Return an HTTP request into an item by fecthing
		 * the appropriate parameters from the POST request
		 *
		 * @return object the item constructed from the POST request
		 * @uses the POST request
		 */
		function requestToItem ()
		{
			$visibility = $this->getFromPost ('visibility', 'private');
			$parentId = $this->getFromPost ('parentId', 0);
			$isParent = $this->getFromPost ('isParent', 0);
			$when_created = $this->getFromPost ('when_created', null);
			$when_modified = $this->getFromPost ('when_modified', null);
			$itemId = $this->getFromPost ('itemId', 0);
			$category = $this->getFromPost ('category', null);
			$name = $this->getFromPost ('name', null);
			$description = $this->getFromPost ('description', null);
			
			$person1 = $this->getFromPost ('person1', null);
			$person2 = $this->getFromPost ('person2', null);
			$theType = $this->getFromPost ('imageURL', null);
			$startDate = $this->getFromPost ('startDate', null);
			$endDate = $this->getFromPost ('endDate', null);
			$location = $this->getFromPost ('location', null);
			$imageURL = $this->getFromPost ('imageURL', null);
			
			$item = new RelationShip (
				$itemId,
				$_SESSION['boobyUsername'],
				$parentId,
				$isParent,
				$name,
				$description,
				$visibility,
				$category,
				$when_created,
				$when_modified,
				$person1,
				$person2,
				$theType,
				$startDate,
				$endDate,
				$location,
				$imageURL
			);
			return $item;
		}
				
}
?>
