<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is release under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('plugins/genealogy/model/RelationShip.php');
require_once ('plugins/genealogy/model/RelationShipFactory.php');
require_once ('plugins/genealogy/model/PersonServices.php');
require_once ('base/model/InformationServices.php');
require_once ('base/model/Services.php');
/**
 * Operations on contacts
 *
 * @author Barry Nauta
 * @date January 2004
 * @package be.nauta.booby.plugins.genealogy.model
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta <br />
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code> 
 * and look for licenses
 */
class RelationShipServices extends Services
{
	/**
 	 * Default constructor
	 */
	function RelationShipServices ()
	{
		parent::Services();
		$this->itemFactory = new RelationShipFactory ();

		include ('plugins/genealogy/sql/relationShipQueries.php');
		$this->queries = $queries;
	}

	/**
	 * Adds a relationship
	 * 
	 * @param integer userId the identifier for the user
	 * @param object item the item to be added
	 *
     * @return integer last know id. This is the id of the relationship
	 * that was newly inserted and for which an id has automatically
	 * been assigned.
	 */
	function addItem ($userId, $item)
	{
//die ($item->description);
 //       if ($_SESSION['username'] != $userId) { return null; }

        global $db;

		$now = date ("Y-m-d H:i:s");
		$query  = sprintf ($this->queries['addItem'],
			$userId, 
			addslashes ($item->parentId), 
			addslashes ($item->isParent), 
			addslashes ($item->name), 
			addslashes ($item->description),
			addslashes ($item->visibility), 
			addslashes ($item->category), 
			addslashes ($now),
			addslashes ($item->person1), 
			addslashes ($item->person2), 
			addslashes ($item->type), 
			addslashes ($item->startDate), 
			addslashes ($item->endDate), 
			addslashes ($item->location),
			addslashes ($item->imageURL));
		$result = $db->Execute($query) 
			or die("AddItem: " . $db->ErrorMsg() . " " . $query);
	}

	/**
	 * Modifies a note.
	 *
 	 * @param integer userId the identifier for the user who modifies a relationship
	 * @param object item the modified note
	 */
	function modifyItem ($userId, $item)
	{
//        if ($_SESSION['username'] != $userId) { return null; }
//		$this->checkOwner ($userId, $item->itemId);
//die ($item->toString ());
        global $db;
		$now = date ("Y-m-d H:i:s");

//die ($item->description);
		$query  = sprintf ($this->queries['modifyItem'], 
			$now, 
			addslashes ($item->name), 
			addslashes ($item->description), 
			addslashes ($item->parentId), 
			addslashes ($item->person1), 
			addslashes ($item->person2), 
			addslashes ($item->type), 
			addslashes ($item->startDate), 
			addslashes ($item->endDate), 
			addslashes ($item->location),
			addslashes ($item->imageURL), 
			$item->itemId) ;
//die ($query);
		$result = $db->Execute($query) 
			or die("ModifyItem: " . $db->ErrorMsg() . " " . $query);
	}
	
	/**
	 * Gets a specific item for a user
	 *
	 * @param string userId the identifier for the user
	 * @param string itemId the identifier for the item
	 * @return object the item for specified user with specified itemId  
	 */
	function getItem ($userId, $itemId)
	{
//		if ($_SESSION['username'] != $userId) { return null; }

		global $db;
//		global $db, $queries;
//		die (print_r ($this->queries));
		$query = sprintf ($this->queries['getItem'], $userId, $itemId, $itemId);
//		die ($query);

		$result = $db->Execute($query) or
			die("GetItem: " .
			$db->ErrorMsg() . " query: -" .
			$query . "-");

		$items = $this->itemFactory->resultsetToItems ($result);
		
//		die (print_r ($items));
		$informationServices = new InformationServices ();
		$personServices = new PersonServices ();
		// Retrieve all information items related to the specific relationships
		$information = $informationServices->getItems ($userId, $person->itemId, 'PERSON');
//		die (print_r ($information));
/*
		foreach ($items as $relationShip)
		{
			if ($information != null)
			{
				foreach ($information as $inf)
				{
					$relationShip->addInformation ($inf);
				}
			}
			$firstPerson =$personServices->getItem ($userId, $relationShip->person1);
//			die (print_r ($firstPerson));
//			$secondPerson = $personServices->getItem ($userId, $relationShip->person2);
			$relationShip->firstPerson = $firstPerson; 
//			$relationShip->secondPerson = $secondPerson;
//die (print_r ($relationShip));
		}
		die (print_r ($items));
*/
		for ($i=0; $i<count($items); $i++)
		{
			$relationShip = $items[$i];

			$firstPerson =$personServices->getItem ($userId, $relationShip->person1);
//			die (print_r ($firstPerson));
			$secondPerson = $personServices->getItem ($userId, $relationShip->person2);
			$relationShip->firstPerson = $firstPerson; 
			$relationShip->secondPerson = $secondPerson;
			if ($information != null)
			{
				for ($j=0; $j<count($information); $j++)
				{
					$inf = $information[$j];
					$relationShip->addInformation ($inf);
				}
			}
			// Why is this needed??????
			$items[$i]=$relationShip;
		}
		return $items;
	}
	
	
}
?>
