drop table if exists booby_genealogy_information;
drop table if exists booby_genealogy_relationship;
drop table if exists booby_genealogy_person;

CREATE TABLE booby_genealogy_information (
  itemId int(11) NOT NULL auto_increment,
  owner varchar(70) NOT NULL default '',
  parentId int(11) NOT NULL default '0',
  isParent tinyint(1) default NULL,
  name varchar(70) NOT NULL default '',
  description text,
  visibility varchar(15) default NULL,
  category varchar(50) default NULL,
  when_created datetime default NULL,
  when_modified datetime default NULL,
  referingId integer NOT NULL,
  referingType char (50) NOT NULL,
  reliability varchar(70) default NULL,
  complete BOOL,
  informationURL varchar(70) default NULL,
  imageURL varchar(70) default NULL,
  comments text,
  PRIMARY KEY  (itemId),
  KEY itemId (itemId)
);


CREATE TABLE booby_genealogy_person (
  itemId int(11) NOT NULL auto_increment,
  owner varchar(70) NOT NULL,
  parentId int(11) NOT NULL default 0,
  isParent tinyint(1) default NULL,
  name varchar(70) default '',
  description text,
  visibility varchar(15) default NULL,
  category varchar(50) default NULL,
  when_created datetime default NULL,
  when_modified datetime default NULL,
  parentId1 int(11) default '0',
  parentId2 int(11) default '0',
  firstName varchar(70) default NULL,
  surName varchar(70) default NULL,
  surNamePrefix varchar(20) default NULL,
  title varchar(70) default NULL,
  alias varchar(70) default NULL,
  gender char(1) default NULL,
  birthDayInMonth int(2) default '0',
  birthMonth int(2) default '0',
  birthYear int(4) default '0',
  birthPlace varchar(70) default NULL,
  deathDayInMonth int(2) default '0',
  deathMonth int(2) default '0',
  deathYear int(4) default '0',
  deathPlace varchar(70) default NULL,
  imageURL varchar(70) default NULL,
  PRIMARY KEY  (itemId),
  KEY itemId (itemId)
);


CREATE TABLE booby_genealogy_relationship (
  itemId int(11) NOT NULL auto_increment,
  owner varchar(70) NOT NULL,
  parentId int(11) NOT NULL default 0,
  isParent tinyint(1) default NULL,
  name varchar(70) default '',
  description text,
  visibility varchar(15) default NULL,
  category varchar(50) default NULL,
  when_created datetime default NULL,
  when_modified datetime default NULL,
  person1 int(11) NOT NULL,
  person2 int(11) NOT NULL,
  theType varchar(70) NOT NULL,
  startDate datetime default NULL,
  endDate datetime default NULL,
  location varchar(70) default NULL,
  imageURL varchar(70) default NULL,
  PRIMARY KEY  (itemId),
  KEY itemId (itemId)
);
