<?php
/**
 * The template file to show a pedigree tree
 * 
 * @package be.nauta.booby.plugins.genealogy.view
 * @author Barry Nauta
 * @copyright Barry Nauta
 * 
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: <code>http://www.gnu.org</code> and look for licenses
 *
 * Enjoy :-)
 */
?><?php

$persons = array ();
$persons [0] = $renderObjects;

$persons [1] = $renderObjects->parents[0];
$persons [2] = $renderObjects->parents[1];

$persons [3] = $persons[1]->parents[0];
$persons [4] = $persons[1]->parents[1];
$persons [5] = $persons[2]->parents[0];
$persons [6] = $persons[2]->parents[1];

$persons [7] = $persons[3]->parents[0];
$persons [8] = $persons[3]->parents[1];
$persons [9] = $persons[4]->parents[0];
$persons [10] = $persons[4]->parents[1];
$persons [11] = $persons[5]->parents[0];
$persons [12] = $persons[5]->parents[1];
$persons [13] = $persons[6]->parents[0];
$persons [14] = $persons[6]->parents[1];

//require_once ('util/HTMLUtils.php');
//die (print_r ($renderObjects));
function block ($bgColor, $top, $left, $height, $width, $zIndex)
{
	$resultString = 'style="position:absolute;';
	$resultString .= 'background-color:'.$bgColor.'; ';
	$resultString .= 'top:'.$top.';';
	$resultString .= 'left:'.$left.';';
	$resultString .= 'height:'.$height.';';
	$resultString .= 'width:'.$width.';';
	$resultString .= 'z-index:'.$zIndex.'; ';
	return $resultString; 
}

function verticalLine ($top, $left, $height)
{
	$resultString  = '<div ';
	$resultString .= block ('#000000', $top, $left, $height, 1, 3);
	$resultString .= '"></div>
	';
	return $resultString; 
}

function horizontalLine ($top, $left, $width)
{
	$resultString  = '<div ';
	$resultString .= block ('#000000', $top, $left, 1, $width, 3);
	$resultString .= '"></div>
	';
	return $resultString; 	
}

function cellOutline ($top, $left, $height, $width, $zIndex)
{
	$resultString  = '<div ';
	$resultString .= block ('#000000', $top, $left, $height, $width, $zIndex);
	$resultString .= '"></div>';
	return $resultString; 
}

function cellShading ($top, $left, $height, $width, $zIndex)
{
	$resultString  = '<div ';
	$resultString .= block ('#bbbbbb', $top, $left, $height, $width, $zIndex);
	$resultString .= '"></div>';
	return $resultString; 
}

function tableCell ($bgColor, $top, $left, $height, $width, $zIndex)
{
	$resultString = block ($bgColor, $top, $left, $height, $width, $zIndex);
	$resultString .= "clip:rect(auto auto ".$height.".px auto)";
	return $resultString; 
}

function cell ($bgColor, $top, $left, $height, $width, $person)
{
	$resultString  = '<div ';
	$resultString .= tableCell ($bgColor, $top, $left, $height, $width, 5);
	$resultString .= '">';
	$resultString .= '<table border="0" cellpadding="5" cellspacing="0" align="center">';
	$resultString .= '<tr><td height="'.$height.'" align="center">';
	if ($person == null || !isset($person->name) || $person->name==null)
	{
		$resultString .= '<span style="font-size:8pt">Unknown</span>';
	}
	else
	{
		$resultString .= '<span style="font-size:11pt">';
		$resultString .= '<a href="';
		$resultString .= 'GenealogyController.php?action=showPerson&itemId='.$person->itemId;
		$resultString .= '">';
		$resultString .= $person->name;
		$resultString .= '</a>';
		$resultString .= '</span>';

		$resultString .= '<br />';
		$resultString .= '<a href="';
		$resultString .= 'GenealogyController.php?action=showPedigree&itemId='.$person->itemId;
		$resultString .= '">';
		$resultString .= '<img align="left" src="plugins/genealogy/view/pics/chart.png" border="0">';
		$resultString .= '</a>';
		
	} 
	$resultString .= '</td></tr>';
	$resultString .= '</table>';
	$resultString .= '</div>';
	$resultString .= cellOutline ($top-1, $left-1, $height+2, $width+2, 4);
	$resultString .= cellShading ($top+3, $left+3, $height+2, $width+2, 1);
	return $resultString; 
}

?>
<div style="position:relative; top:20;left:20;height:600;width:600;">

<?php 
//	echo cell ('#cccc99', 250, 10, 61, 151, 'Elizan Olivia Mirjam Nauta');
	echo cell ('#cccc99', 250, 10, 61, 151, $persons[0]);
	echo horizontalLine (280, 161, 16); 

//	echo cell ('#e4e4b1', 107, 192, 59, 151, 'Barry Nauta');
	echo cell ('#e4e4b1', 107, 192, 59, 151, $persons[1]);
	echo horizontalLine (136, 177, 17); 
	echo horizontalLine (136, 343, 16); 
	echo verticalLine (136, 177, 288); 

//	echo cell ("#e4e4b1", 395, 192, 59, 151, "Genevive Carton de Wiart");
	echo cell ("#e4e4b1", 395, 192, 59, 151, $persons[2]);
	echo horizontalLine (424, 177, 17);
	echo horizontalLine (424, 343, 16);

//	echo cell ("#fcfcc9", 36, 374, 57, 151, 'Dick Nauta');
	echo cell ("#fcfcc9", 36, 374, 57, 151, $persons[3]);
	echo horizontalLine (64, 359, 17);
	echo horizontalLine (64, 525, 16);
	echo verticalLine (64, 359, 144); 

	echo cell ("#fcfcc9", 180, 374, 57, 151, $persons[4]); 
	echo horizontalLine (208, 359, 17);
	echo horizontalLine (208, 525, 16); 

	echo cell ("#fcfcc9", 324, 374, 57, 151, $persons[5]);
	echo horizontalLine (352, 359, 17);
	echo horizontalLine(352, 525, 16);
	echo verticalLine (352, 359, 144);

	echo cell ("#fcfcc9", 468, 374, 57, 151, $persons[6]);
	echo horizontalLine (496, 359, 17);
	echo horizontalLine (496, 525, 16);

	echo cell ("#ffffe1", 1, 556, 55, 151, $persons[7]);
	echo horizontalLine (28, 541, 17);
	echo verticalLine (28, 541, 72); 

	echo cell ("#ffffe1", 73, 556, 55, 151, $persons[8]); 
	echo horizontalLine (100, 541, 17);

	echo cell ("#ffffe1", 145, 556, 55, 151, $persons[9]);
	echo horizontalLine (172, 541, 17); 
	echo verticalLine (172, 541, 72);

	echo cell ("#ffffe1", 217, 556, 55, 151, $persons[10]);
	echo horizontalLine (244, 541, 17);

	echo cell ("#ffffe1", 289, 556, 55, 151, $persons[11]);
	echo horizontalLine (316, 541, 17);
	echo verticalLine (316, 541, 72);

	echo cell ("#ffffe1", 361, 556, 55, 151, $persons[12]);
	echo horizontalLine (388, 541, 17);

	echo cell ("#ffffe1", 433, 556, 55, 151, $persons[13]);
	echo horizontalLine (460, 541, 17);
	echo verticalLine (460, 541, 72);

	echo cell ("#ffffe1", 505, 556, 55, 151, $persons[14]);
	echo horizontalLine (532, 541, 17);
?>
