<?php
/**
 * The template file to show a person
 * 
 * @package be.nauta.booby.plugins.genealogy.view
 * @author Barry Nauta
 * @copyright Barry Nauta
 * 
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: <code>http://www.gnu.org</code> and look for licenses
 *
 * Enjoy :-)
 */
?>
<?php
	$renderActions [] = array (
		'name' => $dictionary['view'],
		'contents' =>
			array (
				array (
						'href' => 'GenealogyController.php?action=showPedigree&itemId='.$renderObjects->itemId,
						'name' => $dictionary ['pedigree']
					), 
					array(
						'href' => 'GenealogyController.php?action=showRelations&referingId='.$renderObjects->itemId,
						'name' => $dictionary['relationShips']
					)
			)
	);
	$renderActions [] = 	array (
				'name'=> $renderObjects->name,
				'contents'=>
				array (
//					array('href' => 'GenealogyController.php?action=import',
//						'name' => $dictionary['import']),
//					array('href' => 'GenealogyController.php?action=export',
//						'name' => $dictionary['export']),
					array(
						'href' => 'GenealogyController.php?action=modifyPersonPre&itemId='.$renderObjects->itemId,
						'name' => $dictionary['modify']
					),
					array(
						'href' => 'GenealogyController.php?action=modifyRelationsPre&itemId=PERSON&referingId='.$renderObjects->itemId,
						'name' => $dictionary['modifyRelations']
					),
					array(
						'href' => 'GenealogyController.php?action=modifyInformationPre&referingType=PERSON&referingId='.$renderObjects->itemId,
						'name' => $dictionary['modifyInformation']
					),
					array(
						'href' => 'GenealogyController.php?action=addInformationPre&referingType=PERSON&itemId='.$renderObjects->itemId,
						'name' => $dictionary['addInformation']
					)
				)
			);
	
		$icons['camera']='<img src="plugins/genealogy/view/pics/camera.png" border="0">';
?>
<?php  /* echo (print_r ($renderObjects)) */  ?>
<table border="0" width="100%">
<tr>
	<td><h2><?php echo $dictionary['showPersonInformation'] ?></h2></td>
</tr>
</table>
 
<table width="100%" border="0">
	<tr>
		<td>
			<table border="0" cellpadding="3" cellspacing="3<">
				<tr>
					<td>
						<?php echo $dictionary['name'] ?>: 
					</td>
					<td>
						<?php echo $renderObjects->name ?>
					</td>
				</tr>
				<tr>
					<td>
							<?php echo $dictionary['firstName'] ?>
					</td>
					<td>
							<?php echo $renderObjects->firstName ?>
					</td>
				</tr>
				<tr>
					<td>
							<?php echo $dictionary['surName'] ?>
					</td>
					<td>
							<?php echo $renderObjects->surName ?>
					</td>
				</tr>
				<tr>
					<td>
							<?php echo $dictionary['surNamePrefix'] ?>
					</td>
					<td>
							<?php echo $renderObjects->surNamePrefix ?>
					</td>
				</tr>
				<tr>
					<td>
						<?php echo $dictionary['gender'] ?>
					</td>
					<td>
							<?php 
								if ($renderObjects->gender == 'M')
								{
									echo $dictionary['male'];
								}
								else if ($renderObjects->gender == 'F')
								{
									echo $dictionary['female'];
								}
								else
								{
									echo $dictionary['unknown'];
								}
							?> 
					</td>
				</tr>
				<tr>
					<td>
						<?php echo $dictionary['title'] ?>
					</td>
						<td>
							<?php echo $renderObjects->title ?>
						</td>
				</tr>
				<tr>
					<td>
						<?php echo $dictionary['alias'] ?>:
					</td>
					<td>
						<?php echo $renderObjects->alias ?>
					</td>
				</tr>
				<tr>
					<td>
						<?php echo $dictionary['birthDate'] ?>:
					</td>
					<td>
							<?php 
								echo ($dictionary['day']);
								echo ('/');
								echo ($dictionary['month']);
								echo ('/');
								echo ($dictionary['year']);
								echo ('&nbsp;');
								echo ('&nbsp;');
								echo ($renderObjects->birthDayInMonth);
								echo ('/');
								echo ($renderObjects->birthMonth);
								echo ('/');
								echo ($renderObjects->birthYear);
							?>
					</td>
				</tr>
				<tr>
					<td>
						<?php echo $dictionary['deathDate'] ?>
					</td>
					<td>
							<?php 
								echo ($dictionary['day']);
								echo ('/');
								echo ($dictionary['month']);
								echo ('/');
								echo ($dictionary['year']);
								echo ('&nbsp;');
								echo ('&nbsp;');
								echo ($renderObjects->deathDayInMonth);
								echo ('/');
								echo ($renderObjects->deathMonth);
								echo ('/');
								echo ($renderObjects->deathYear);
							?>
					</td>
				</tr>
				<tr>
					<td>
						<?php echo $dictionary['birthPlace'] ?>
					</td>
					<td>
							<?php echo $renderObjects->birthPlace ?>
					</td>
				</tr>
				<tr>
					<td>
						<?php echo $dictionary['deathPlace'] ?>
					</td>
					<td>
							<?php echo $renderObjects->deathPlace ?>
					</td>
				</tr>
				<tr>
					<td valign="top"><?php echo $dictionary['description'] ?>: </td>
					<td colspan="3">
						<?php echo $renderObjects->description ?>
					</td>
				</tr>
			</table>
		</td>
		<td valign="top">
			<?php 
				if ($renderObjects->imageURL != null)
				{
					echo ('<img src="'.$renderObjects->imageURL.'">');
				}
			?>
		</td>
		<td>
			<table>
				<tr>
					<td>
						<!-- 
							Parents
						-->
						<h2><?php echo $dictionary['parents'] ?></h2>
						<hr />
						<?php
							if ($renderObjects->parents != null)
							{
								echo ('<ul>');
								foreach ($renderObjects->parents as $parent)
								{
									echo ('<li>');
									echo ('<a href="GenealogyController.php?action=showPerson');
									echo ('&itemId='.$parent->itemId.'">'.$parent->name.'</a>');
									echo ('</li>');
								}
								echo ('<ul>');
							}
						?>
					</td>
				</tr>
				<tr>
					<td>
						<!--
							Marriage(s)
						-->
						<h2><?php echo $dictionary['marriage'] ?></h2>
						<hr />
						<?php
							if ($renderObjects->marriages != null)
							{
								echo ('<ul>');
								foreach ($renderObjects->marriages as $marriage)
								{
									echo ('<li>');
									echo ('<a href="GenealogyController.php?action=showPerson');
									echo ('&itemId='.$marriage->itemId.'">'.$marriage->name.'</a>');
									echo ('</li>');
								}
								echo ('<ul>');
							}
						?>
					</td>
				</tr>
				<tr>
					<td>
						<!--
							Children
						-->
						<h2><?php echo $dictionary['children'] ?></h2>
						<hr />
						<?php
							if ($renderObjects->children != null)
							{
								echo ('<ul>');
								foreach ($renderObjects->children as $child)
								{
									
									echo ('<li>');
									echo ('<a href="GenealogyController.php?action=showPerson');
									echo ('&itemId='.$child->itemId.'">'.$child->name.'</a>');
									echo ('</li>');
								}
								echo ('<ul>');
							}
						?>
					</td>
				</tr>
			</table>
		</td>
	</tr>
</table>

<!--
 	The information
 -->
<hr />
<h2><?php echo $dictionary['information'] ?></h2>
<?php 
	if ($renderObjects -> information != null)
	{
?>
<table border="0" width="100%">
	<?php
		for ($i=0; $i<count($renderObjects->information); $i++)
		{
			if ($i % 2 == 0)
			{
	?>
			<tr class="even">
	<?php
			}
			else
			{
	?>
			<tr class="odd">
	<?php
			}
	?>
				<td>
					<?php 
						if ($renderObjects->information[$i]->imageURL != null)
						{
							echo ('<a href="'.$renderObjects->information[$i]->imageURL.'">');
							echo ($icons['camera']);
							echo ('</a>');
						}
						else
						{
							echo ("&nbsp;");
						}
					?>
				</td>
				<td>
					<?php echo $renderObjects->information[$i]->name ?>
				</td>
				<td>
					<?php echo $renderObjects->information[$i]->description ?>
				</td>
				<td>
					<?php echo $renderObjects->information[$i]->comments ?>
				</td>
			</tr>
	<?php
		}
	?>
</table>
<?php
	}
?>
