<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('base/model/ItemFactory.php');
require_once ('plugins/news/model/News.php');

require_class('RequestCast', 'base/util/request/RequestCast.class.php');
require_class('ClassHelper', 'base/util/ClassHelper.class.php');
/**
 * NewsFactory
 *
 * @author Barry Nauta July 2003
 * @package be.nauta.booby.plugins.news.model
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code> 
 * and look for licenses
 */
class NewsFactory extends ItemFactory
{
		/**
		 * Default constructor
		 */
		function NewsFactory ()
		{
			parent::ItemFactory ();
		}
		
		/**
		 * Returns the type of this specific item
		 * @return string the type of this specific item: <code>News</code>
		 */
		function getType ()
		{
			return "News";
		}
		
		/**
		 * Factory method. Return an HTTP request into an item by fecthing
		 * the appropriate parameters from the POST request
		 * 
		 * Overrides the parent method to add an Bookmark-specific error condition :
		 * If the locator is missing, and if it's not parent, we have an error
		 *
		 * @return object the item constructed from the POST request
		 * @author Michael Haussmann
		 * @uses the POST request
		 */
		function requestToItem ($item = null)
		{
			$item = parent::requestToItem($item);
			if(!$item->isParent && ($item->locator == "http://" ||
				$item->locator == ""))
			{
				$this->requestCast->addError("locatorMissing");
			}
			return $item;
		}

}
?>
