<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('plugins/news/model/News.php');
require_once ('plugins/news/model/NewsFactory.php');
require_once ('base/model/Services.php');
/**
 * News operations (RSS/RDF). The BusinessLogic operations that can be
 * performed on News
 *
 * @author Barry Nauta February 2003
 * @package be.nauta.booby.plugins.news.model
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>www.gnu.org</code> 
 * and look for licenses
 */
class NewsServices extends Services
{

	/**
	 * Default constructor
	 */
	function NewsServices ()
	{
		parent :: Services ();
		$this->itemFactory = new NewsFactory ();

		include ('plugins/news/sql/newsQueries.php');
		$this->queries = $queries;
	}

	/**
	 * Adds a news item for a user
	 *
	 * @param integer userId the identifier for the user
	 * @param object item the news item to be added
	 * @return dont know anymore TBD FIXME BARRY
	 */
	function addItem ($userId, $item)
	{
		global $db;
		$now = date ("Y-m-d H:i:s");
		$query = sprintf ($this->queries['addItem'],
			$userId, 
			addslashes ($item->parentId), 
			addslashes ($item->isParent),
			addslashes ($item->name), 
			addslashes ($item->description),
			addslashes ($item->visibility), 
			addslashes ($item->category), 
			addslashes ($now), 
			addslashes ($item->locator));
			
		$db->Execute ($query) or die ('AddNews: not able to add
			bookmark ' . $query . " " . $db->ErrorMsg());

		// todo move to base Service class?
		$query = $this->queries['lastItemInsertId'];
		$result=$db->Execute($query)
			or die ("addNews: " .
				$db->ErrorMsg () . " " . $query);
		return $result->fields[0];
	}


	/**
	 * Modifies an item
	 *
	 * @param integer userId the identifier of the user who modifies
	 * a bookmark
	 * @param object item the modified item
	 */
	function modifyItem ($userId, $item)
	{
		global $db;
		$now = date ("Y-m-d H:s");

		$query = sprintf ($this->queries['modifyItem'],
			$now, 
			addslashes ($item->name), 
			addslashes ($item->parentId),
			addslashes ($item->visibility),
			addslashes (trim($item->description)), 
			addslashes ($item->locator), 
			$item->itemId);
			
		$result = $db->Execute ($query) or die
			("ModifyItem Error: " .
				$db->ErrorMsg () . " " . $query);
	}

}
?>
