<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('plugins/notes/model/Note.php');
require_once ('plugins/notes/model/NoteFactory.php');
require_once ('base/model/Services.php');
/**
 * Operations on contacts
 *
 * @author Barry Nauta March 2003
 * @package be.nauta.booby.plugins.notes.model
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code>
 * and look for licenses
 */
class NoteServices extends Services
{
	/**
 	 * Default constructor
	 */
	function NoteServices ()
	{
		parent::Services();
		$this->itemFactory = new NoteFactory ();

		include ('plugins/notes/sql/noteQueries.php');
		$this->queries = $queries;
	}

	/**
	 * Adds a note for a user
	 * 
	 * @param integer userId the identifier for the user
	 * @param object item the item to be added
	 *
     * @return integer last know id. This is the id of the item
	 * that was newly inserted and for which an id has automatically
	 * been assigned.
	 */
	function addItem ($userId, $item)
	{
        global $db;
		$now = date ("Y-m-d H:i:s");
		$query  = sprintf ($this->queries['addItem'],
			$userId, 
			addslashes ($item->parentId), 
			addslashes ($item->isParent), 
			addslashes ($item->name), 
			addslashes ($item->description),
			addslashes ($item->visibility), 
			addslashes ($item->category), 
			$now);
		$result = $db->Execute($query) 
			or die("AddNote: " . $db->ErrorMsg() . " " . $query);
	}

	/**
	 * Modifies a note.
	 *
 	 * @param integer userId the identifier for the user who modifies a note
	 * @param object item the modified note
	 */
	function modifyItem ($userId, $item)
	{
        global $db;
		$now = date ("Y-m-d H:i:s");

		$query  = sprintf ($this->queries['modifyItem'], 
			$now, 
			addslashes ($item->name), 
			addslashes ($item->visibility),
			addslashes ($item->description), 
			addslashes ($item->parentId), 
			$item->itemId) ;
			
		$result = $db->Execute($query) 
			or die("ModifyNote: " . $db->ErrorMsg() . " " . $query);
	}
}
?>
