<?php
/**
 * The template file to show notes
 * 
 * @package be.nauta.booby.plugins.notes.view
 * @author Barry Nauta
 * @copyright Barry Nauta
 * 
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: <code>http://www.gnu.org</code> and look for licenses
 *
 * Enjoy :-)
 */
?> 
<!--
	Set some custom colors for the popup notes
-->
<script language="JavaScript">
	var ol_textcolor="#000000";
	var ol_capcolor="#000000";
	var ol_bgcolor="#ffee00";
	var ol_fgcolor="#ffff00";
</script>

<?php
		/*
		 * Show the ancestor path. Contributed by Michael
		 */
		if(isset($parameters['ancestors']) && $parentId != 0)
		{
			echo ('<!-- Ancestors -->');
			echo ('<table><tr>');
			
			// The root link
			echo ('<td><a href="?parentId=0" class="ancestor">'.$dictionary['root'].'</a></td>');
	
			// all ancestors other than root
			foreach($parameters['ancestors'] as $ancestor)
			{ 
				echo ('<td>&nbsp;/&nbsp;');
				echo ('<a href="?parentId='.$ancestor->itemId.'" class="ancestor">');
				echo ($ancestor->name);
				echo ('</a>');
				echo ('</td>');
			}
			echo ('</tr></table>');
		}		

		include ('templates/'.$_SESSION['booby_template'].'/icons.inc');
		$configuration = array ();
		/*
		 * Build up a proper configuration for the tree display.
		 */
		$configuration['icons']=$icons;
		$configuration['dictionary']=$dictionary;
		$configuration['callback']='NoteController.php';
		
		/*
		 * Check for conditional overlib
		 */
		if (isset ($_SESSION['noteOverlib']))
		{
			$configuration ['overlib'] =$_SESSION['noteOverlib'];
		}
		else
		{
			$configuration ['overlib'] = true;
		}

		/*
		 * Explorer like tree
		 */
		if (isset ($_SESSION['noteTree']) && $_SESSION['noteTree'] == 'Explorer')
		{
			include_once "base/view/Tree.php";
			include_once "plugins/notes/view/NoteExplorerTreeDelegate.php";
			$delegate = new NoteExplorerTreeDelegate ($configuration);
			$tree = new Tree ($delegate, $configuration);
			/*
			 * Do we show expanded items? (This is not a useful option in the yahoo tree)
			 */
			if (isset ($_SESSION['noteExpand']))
			{
				$tree -> setExpanded ($_SESSION['noteExpand']);
			}
		}
		/*
		 * Yahoo like tree
		 */
		else
		{
			/*
			 * Build up a proper configuration for the tree display, this makes only sense for
			 * the yahoo-like tree
			 */
			if (isset ($_SESSION['noteYahooTreeColumnCount']))
			{
				$configuration ['numberOfColumns'] =$_SESSION['noteYahooTreeColumnCount'];
			}
			else
			{
				$configuration ['numberOfColumns'] = 2;
			}
			include_once "base/view/YahooTree.php";
			include_once "plugins/notes/view/NoteYahooTreeDelegate.php";
			$delegate = new NoteYahooTreeDelegate ($configuration);
			$tree = new YahooTree ($delegate, $configuration);
		}

		/*
		 * Now actually show the layout
		 */
		echo ($tree -> toHtml ($parent, $renderObjects));
?>
