<?php
/*
 * vim: set tabstop=4 :
 * vim: set number :
 *
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('base/Controller.php');
require_once ('plugins/sysinfo/model/SysInfoServices.php');
/**
 * The SysInfo controller
 *
 * @author Barry Nauta June 2004
 * @package be.nauta.booby.plugins.sysinfo
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code>
 * and look for licenses
 */
class SysInfoController extends Controller
{
	/**
	 * Default constructor
	 */
	function SysInfoController ()
	{
		parent::Controller ();
		
		$this->title = 'Booby - SysInfo';
		$this->pluginName = 'sysinfo';
		$this->itemName = 'SysInfo';
		$this->operations = new SysInfoServices ();
	}
	
	function getActions ()
	{
	}
	
	function activate ()
	{
		$dictionary = $this->getDictionary ();
		$this->renderObjects= $this->operations->getSysInfo();
		$this->renderer = 'sysinfo';
	}
	
	/**
	 * Display which basically means that the template will be invoked
	 */
	function displayObsolete ()
	{
		include ('base/config/languages.php');
		include ('base/config/templates.php');
		global $menuItems, $menu;

		$this->renderEngine->assign('pluginName', $this->getTitle ());
		$this->renderEngine->assign('title', $this->getTitle ());
		$this->renderEngine->assign('menuItems', $menuItems);
		$this->renderEngine->assign('menu', $menu);
		$this->renderEngine->assign('dictionary', $this->getDictionary ());

		//$this->renderEngine->assign('itemId', $this->getItemId ());
		//$this->renderEngine->assign('parentId', $this->getParentId ());

		$this->renderEngine->assign('parameters', 
			$this->getParameters ());
		$this->renderEngine->assign('action', 
			$this->getAction ());
		$this->renderEngine->assign('renderObjects', 
			$this->getRenderObjects ());
		$this->renderEngine->assign('renderActions', 
			$this->getActions ());
		$this->renderEngine->assign ('renderer', $this->getTemplateFile ());
	
		$this->renderEngine->assign ('languages', $languages);
		$this->renderEngine->assign ('templates', $templates);
		if (isset ($_GET['debug']))
		{
			error_reporting(E_ALL);			
			$this->renderEngine->display('templates/'.$this->getTemplate().'/template.tpl.php');
			// todo add more
		}
		else
		{
			error_reporting(E_ERROR);
			@$this->renderEngine->display('templates/'.$this->getTemplate().'/template.tpl.php');
		}
	}
}

/*
if ($_SESSION['boobyUsername'] != 'admin')
{
	die ('The SysInfo page can only be accessed by the administrator!');
}
$controller = new SysInfoController ();
$controller -> activate ();
$controller -> display ();
*/
?>

