<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('base/util/ArrayUtils.php');
/**
 * SysInfo Services
 *
 * @author Barry Nauta June 2004
 * @package be.nauta.booby.plugins.sysinfo.model
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta <br />
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code> 
 * and look for licenses
 */
class SysInfoServices 
{
	var $arrayUtils;
	/**
	 * Default constructor
	 */
 	function SysInfoServices ()
 	{
		$this->arrayUtils = new ArrayUtils ();
 	}
 	

	function getSysInfo ()
	{
		$result = array ();
		$result[0]['name']='Settings';
		$result[0]['contents'][] = array (
					'name'=>'xml_parser_create',
					'value'=>function_exists ('xml_parser_create')
				);
		$result[0]['contents'][] = array (
					'name'=>'xml_extension_loaded',
					'value'=>extension_loaded('xml')
				);
		$result[0]['contents'][] = array (
					'name'=>'get_magic_quotes_gpc',
					'value'=>get_magic_quotes_gpc()
				);
		$result[1]['name']='Globals';
		$result[1]['contents'][] = array (
					'name'=>'$_SESSION',
					'value'=>$this->arrayUtils->
						implode_with_keys (', ',$_SESSION)
				);
		$result[1]['contents'][] = array (
					'name'=>'$_COOKIE',
					'value'=>$this->arrayUtils->
						implode_with_keys (', ',$_COOKIE)
				);
		$result[1]['contents'][] = array (
					'name'=>'$_ENV',
					'value'=>$this->arrayUtils->
						implode_with_keys (', ',$_ENV)
				);
		$result[1]['contents'][] = array (
					'name'=>'$_SERVER',
					'value'=>$this->arrayUtils->
						implode_with_keys (', ',$_SERVER)
				);
		if (function_exists ('apache_get_version')
			&& function_exists ('apache_get_modules'))
		{
			$result[2]['name']='Apache';
			$result[2]['contents'][] = array (
					'name'=>'apache_get_version',
					'value'=>apache_get_version()
				);
			$result[2]['contents'][] = array (
					'name'=>'apache_get_modules',
					'value'=>$this->arrayUtils->
						implode_with_keys(', ', apache_get_modules())
				);
		}
		return $result;
	}
}
?>

