<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('base/model/Item.php');
/**
 * A Todo item.
 * 
 * @author Barry Nauta March 2003
 * @package be.nauta.booby.plugins.todo.model
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta <br />
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code> 
 * and look for licenses
 */
class Todo extends Item 
{
	/**
	 * The priority of this item
	 * @access private
	 * @var integer
	 */
	var $priority;
	
	/**
	 * The startdate of this item
	 * @access private
	 * @var string
	 */
	var $startDate;

	/**
	 * The enddate of this item
	 * @access private
	 * @var string 
	 */
	var $endDate;
	
	/**
	 * The status of this item
	 * @access private
	 * @var string 
	 */
	var $status;

	/**
	 * The percentage completed of this item
	 * @access private
	 * @var integer 
	 */
	var $percentComplete;
	
	/**
	 * Indicator whether this todo item is finished
	 * @access private
	 * @var bool
	 */
	var $isFinished;

	/**
	 * Full blown constructor with all parameters
	 *
	 * @param integer theItemId the id of the item
	 * @param string theOwner who owns this item?
	 * @param integer theParentId what is the id of the parent of this item?
	 * @param boolean parent is this a parent (true) or child (false)
	 * @param string theName the name of this item
	 * @param string theDescription the description of this item
	 * @param string theVisibility the visibility (private or public)
	 * @param string theCategory what is the category of this item?
	 * @param string theCreation When was this item created?
	 * @param string theModified When was this item modified?
	 * @param integer thePriority The priority of this item
	 * @param string theStartDate the start date of this todo item
	 * @param string theEndDate the end date of this todo item
	 * @param string theStatus the status of this item
	 * @param integer percCompleted percentage completed
	 * @param boolean finished is this todo item finished yet?
  	 */
	function Todo ($theID, $theOwner, $theParentId, $parent, $theName, 
		$theDescription, $theVisibility, $theCategory, 
		$theCreation, $theModified,
		$thePriority, $theStartDate,$theEndDate,
		$theStatus, $percCompleted, $finished)
	{
		parent :: Item ($theID, $theOwner, $theParentId, $parent,
				$theName, $theDescription, $theVisibility,
				$theCategory, $theCreation, $theModified);
		
		$this->type="Todo"; 
		$this->priority = $thePriority;
		$this->startDate = $theStartDate;
		$this->endDate = $theEndDate;
		$this->status=$theStatus;
		$this->percentComplete=$percCompleted;
		$this->isFinished = $finished;
	}
}
?>
