<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('base/model/ItemFactory.php');
require_once ('plugins/todos/model/Todo.php');
/**
 * TodoFactory
 *
 * @author Barry Nauta July 2003
 * @package be.nauta.booby.plugins.todo.model
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta 
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code> 
 * and look for licenses
 */
class TodoFactory extends ItemFactory
{
		/**
		 * Default constructor
		 */
		function TodoFactory ()
		{
			parent::ItemFactory ();
		}
		
		/**
		 * Returns the type of this specific item
		 * @return string the type of this specific item: <code>Todo</code>
		 */
		function getType ()
		{
			return "Todo";
		}
		
		/**
		 * Factory method. Return an HTTP request into an item by fecthing
		 * the appropriate parameters from the POST request
		 *
		 * @return object the item constructed from the POST request
		 * @uses the POST request
		 */
		function requestToItem ()
		{
			$visibility = $this->getFromPost ('visibility', 'private');
			$parentId = $this->getFromPost ('parentId', 0);
			$isParent = $this->getFromPost ('isParent', 0);
			$when_created = $this->getFromPost ('when_created', null);
			$when_modified = $this->getFromPost ('when_modified', null);
			$itemId = $this->getFromPost ('itemId', 0);
			$category = $this->getFromPost ('category', null);
			$description = $this->getFromPost ('description', null);
			$isFinished = $this->getFromPost('isFinished', 'false');
		    $percComplete = $this->getFromPost ('percentComplete', 0);
			$priority = $this->getFromPost ('priority', 0);
			$status = $this->getFromPost ('status', null);
			
			$startyear = $_POST['StartDate_Year'];
			$startmonth = $_POST['StartDate_Month'];
			$startday = $_POST['StartDate_Day'];
			$startDate = $startyear . '-' . $startmonth . '-' . $startday;
		
			$endyear = $_POST['DueDate_Year'];
			$endmonth = $_POST['DueDate_Month'];
			$endday = $_POST['DueDate_Day'];
			$endDate = $endyear . '-' . $endmonth . '-' . $endday;
		
			$name = $this->stringUtils->gpcStripSlashes ($_POST['name']);
			
			$todo = new Todo (
				$itemId,
				$_SESSION['boobyUsername'],
				$parentId,
				$isParent,
		        $name,
		        $description,
				$visibility,
				$category,
				$when_created,
				$when_modified,
		        $priority,
				$startDate,
				$endDate,
		    	$status,
				$percComplete,
				$isFinished
			);
			return $todo;
		}
}
?>
