<?php
/*
 * vim: set number : 
 * vim: set tabstop=4 : 
 *
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('plugins/todos/model/Todo.php');
require_once ('plugins/todos/model/TodoFactory.php');
require_once ('base/model/Services.php');
/**
 * Operations on todos
 *
 * @author Barry Nauta March 2003
 * @package be.nauta.booby.plugins.todo.model
 * @copyright 
 *
 * Copyright (c) 2003 - 2004 Barry Nauta 
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code> 
 * and look for licenses
 */
class TodoServices extends Services
{
	/**
 	 * Default constructor
	 */
	function TodoServices ()
	{
		parent::Services();
		$this->itemFactory = new TodoFactory ();
	
		include ('plugins/todos/sql/todoQueries.php');
		$this->queries = $queries;
	}
 
	/**
	 * Adds a todo item for a specific user
	 *
	 * @param string userId the identifier for the user
	 * @param object item the todo item to be added
	 */
	function addItem ($userId, $item)
	{
 		if (!$item->isValid ()){ return null; }
		global $db;
		$now = date ("Y-m-d H:i:s");

		$query = sprintf ($this->queries['addItem'],
			$userId, 
			addslashes ($item->parentId), 
			addslashes ($item->isParent),
			addslashes ($item->name), 
			addslashes ($item->description),
			addslashes ($item->visibility), 
			addslashes ($now), 
			addslashes ($item->priority), 
			addslashes ($item->startDate), 
			addslashes ($item->endDate),
			addslashes ($item->status),
			addslashes ($item->percentComplete), 
			'false');

		$result = $db->Execute($query) 
			or die("Add todo: " . $db->ErrorMsg() . " " . $query);	
	}

	/**
	 * Modifies a todo item
	 *
 	 * @param string userId the identifier for the user
	 * @param object item the modified item
	 */
	function modifyItem ($userId, $item)
	{
 		global $db;
		$now = date ("Y-m-d H:i:s");

		if ($parentId != 0)
		{
			$parent = $this->getItem ($userId, $item->parentId);
			if (!$parent->isParent ())
			{
				die ('Can only move items to folders');
			}
		}
		$query = sprintf ($this->queries['modifyItem'],
			$now, 
			addslashes ($item->name), 
			addslashes ($item->visibility),
			addslashes ($item->description),
			addslashes ($item->priority), 
			addslashes ($item->status), 
			addslashes ($item->startDate),
			addslashes ($item->endDate), 
			addslashes ($item->percentComplete), 
			addslashes ($item->parentId), 
			addslashes ($item->itemId));
		$result = $db->Execute($query) 
			or die("ModifyTodo: " . $db->ErrorMsg() . " " . $query);
	}
}
?>
