<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('base/util/request/RequestCastConfiguration.php');
/**
 * The Request cast configuration class knows about the inner details 
 * of a class that needs to be casted.
 *
 * @package be.nauta.booby.plugins.todos.util.request
 * @author Michael Haussmann 11/02/2004
 * @copyright Michael Haussmann
 */
class TodoRequestCastConfiguration 
{
	/**
	 * Default constructor. Does nothing (for the moment?)
	 */
	function TodoRequestCastConfiguration ()
	{
		parent::RequestCastConfiguration ();
	}

	/**
	 * Returns the configuration mapping between a POST and an Object.
	 * (may be refactored as to use an XML config file).
	 *
	 *
	 * @return array
	 * This array is composed like this :
	 * - key : numeric
	 * - values :
	 * - name of the field
	 * - minimal required (1 means mandatory, more than 1 is for arrays)
	 * - maximal required (more than 1 is for arrays)
	 * - type, can be string (everything), alpha, digit, mail. 
	 * - error message if no match on min/max/type
	 * - default value
	 */
	function getFieldMapping($className)
	{
		switch(strtolower($className))
		{
			case strtolower("Todo"):
				$config[] = array(
					"name" => "itemId", 
					"field" => "itemId", 
					"min" => 0,
					"max" => 1,
					"type" => "digit",
					"message" => "",
					"default" => 0);
					
				$config[] = array(
					"name" => "parentId", 
					"field" => "parentId",
					"min" => 0,
					"max" => 1,
					"type" => "digit",
					"message" => "",
					"default" => 0);
				
				$config[] = array(
					"name" => "isParent", 
					"field" => "isParent", 
					"min" => 0,
					"max" => 1,
					"type" => "digit",
					"message" => "",
					"default" => 0);
				
				$config[] = array(
					"name" => "visibility", 
					"field" => "visibility", 
					"min" => 0,
					"max" => 1,
					"type" => "alpha",
					"message" => "",
					"default" => "private");
					
				$config[] = array(
					"name" => "when_created", 
					"field" => "when_created", 
					"min" => 0,
					"max" => 1,
					"type" => "string",
					"message" => "",
					"default" => null);
					
				$config[] = array(
					"name" => "when_modified", 
					"field" => "when_modified", 
					"min" => 0,
					"max" => 1,
					"type" => "string",
					"message" => "",
					"default" => null);

				$config[] = array(
					"name" => "name", 
					"field" => "name", 
					"min" => 1,
					"max" => 1,
					"type" => "string",
					"message" => "nameMissing",
					"default" => null);		

				$config[] = array(
					"name" => "description", 
					"field" => "description", 
					"min" => 0,
					"max" => 1,
					"type" => "string",
					"message" => "",
					"default" => null);	

				$config[] = array(
					"name" => "priority", 
					"field" => "priority", 
					"min" => 0,
					"max" => 1,
					"type" => "digit",
					"message" => "",
					"default" => "1");

				$config[] = array(
					"name" => "startDate", 
					"field" => "startDate", 
					"min" => 0,
					"max" => 1,
					"type" => "string",
					"message" => "",
					"default" => "1");

				$config[] = array(
					"name" => "endDate", 
					"field" => "endDate", 
					"min" => 0,
					"max" => 1,
					"type" => "string",
					"message" => "",
					"default" => "1");

				$config[] = array(
					"name" => "isFinished", 
					"field" => "isFinished", 
					"min" => 0,
					"max" => 1,
					"type" => "digit",
					"message" => "",
					"default" => "0");

				$config[] = array(
					"name" => "status", 
					"field" => "status", 
					"min" => 0,
					"max" => 1,
					"type" => "string",
					"message" => "",
					"default" => "");

				$config[] = array(
					"name" => "type", 
					"field" => "type", 
					"min" => 0,
					"max" => 1,
					"type" => "string",
					"message" => "",
					"default" => "Todo");
					
				return $config;
				break;
		}
	}
}
?>
