<?php
/**
 * vim: set tabstop=4 :
 * vim: set number : 
 *
 * The template file to modify a task
 * 
 * @package be.nauta.booby.plugins.todos.view
 * @author Barry Nauta
 * @copyright Barry Nauta
 * 
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: <code>http://www.gnu.org</code> and look for licenses
 *
 * Enjoy :-)
 */

	require_once ('base/util/DateUtils.php');
	require_once ('base/util/StringUtils.php');

	$dateUtils = new DateUtils ();
	$stringUtils = new StringUtils ();
?>
<table border="0" width="100%">
<tr>
	<td><h2><?php echo $dictionary['modify'] ?>&nbsp;<?php echo $dictionary['todo'] ?></h2></td>
</tr>
</table>



<form method="POST" action="TodoController.php">
	<table width="80%" border="0">
	<tr>
		<td>
			<?php echo $dictionary['title'] ?>: <input type="text" name="name"
			size="40" value="<?php echo $stringUtils->urlEncode ($renderObjects->name) ?>" />
		</td>
		<td>
			parentId: 
			<input type="text" name="parentId" size="3" 
				value="<?php echo $renderObjects->parentId ?>"/>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo $dictionary['item_public'] ?>: <input type="radio" name="visibility"
				value="public" <?php if($renderObjects->visibility == "public") echo "checked" ?> /><br />
			<?php echo $dictionary['item_private'] ?>: <input type="radio" name="visibility"
				value="private" <?php if($renderObjects->visibility == "private") echo "checked" ?> />
		</td>
		<td>
			&nbsp;
		</td>
	</tr>
	<tr>
		<td>
		<table>
		<tr>
			<td>
		<?php echo $dictionary['priority'] ?>:
			<select name="priority">
		<?php
			$options = array (
					1=>$dictionary['priority1'], 
					2=>$dictionary['priority2'], 
					3=>$dictionary['priority3'], 
					4=>$dictionary['priority4'], 
					5=>$dictionary['priority5']);
			$this->plugin ('options', $options, $stringUtils->urlEncode ($renderObjects->priority));
		?>
			</select>
		</td>
		<td>
			<?php echo $dictionary['complete'] ?>: <input type="text" name="percentComplete"
			size="3"
			value="<?php echo $stringUtils->urlEncode ($renderObjects->percentComplete) ?>"> %
		</td>
		</tr>
		<tr>
			<td><?php echo $dictionary['status'] ?>:
			</td>
			<td><input type="textfield" name="status"
				value="<?php echo $stringUtils->urlEncode ($renderObjects->status) ?>">
			</td>
		</tr>

		</table>
		</td>
		<td>
			<table>
			<tr>
				<td>
					<?php echo $dictionary['start_date'] ?>:
				</td>
				<td>
					<!--
						Month dropdown box
					-->
					<select name="StartDate_Month">
					<?php
						for ($i=1; $i<=12; $i++)
						{
							if ($i<10)
							{
								$currentMonth="month0$i";
							}
							else
							{
								$currentMonth="month$i";
							}
	       					echo ('<option label="'.$dictionary[$currentMonth].'" value="'.$i.'"');
	       					if ($i==$dateUtils->getMonthFromDate($renderObjects->startDate))
	       					{
	       						echo (' selected="selected"');
	       					}
	       					echo ('>'.$dictionary[$currentMonth].'</option>');
	       				}
       				?>
       				</select>
					<!--
						Day dropdown box
					-->
					<select name="StartDate_Day">
					<?php
						for ($i=1; $i<=31; $i++)
						{
							if ($i<10)
							{
								$currentDay = '0'.$i;
							}
							else
							{
								$currentDay = $i;
							}
							echo ('<option label="'.$currentDay.'" value="'.$currentDay.'"');
							if ($i == $dateUtils->getDayInMonthFromDate($renderObjects->startDate))
							{
								echo (' selected="selected"');
							}
							echo ('>'.$currentDay.'</option>');
						}
					?>
					</select>
					<!--
						Year dropdown box
					-->
					<select name="StartDate_Year">
					<?php
						$currentYear = $dateUtils->getYearFromDate ($renderObjects->startDate);

						for ($i=5; $i>10; $i--)
						{
							echo ('<option label="'.($currentYear-$i).'" value="'.($currentYear-$i).'"');
							echo ('>'.($currentYear-$i).'</option>');
						}
						echo ('<option label="'.$currentYear.'" value="'.$currentYear.'"');
						echo (' selected="selected"');
						echo ('>'.$currentYear.'</option>');
						for ($i=1; $i<=10; $i++)
						{
							echo ('<option label="'.($currentYear+$i).'" value="'.($currentYear+$i).'"');
							echo ('>'.($currentYear+$i).'</option>');
						}
					?>
					</select>

				<!--

					<php echo html_select_date
					end_year="+10"
					prefix="StartDate_"
					time=$renderObjects->startDate >
					-->
				</td>
			</tr>
			<tr>
				<td>
					<?php echo $dictionary['due_date'] ?>:
				</td>
				<td>
					<!--
						Month dropdown box
					-->
					<select name="DueDate_Month">
					<?php
						for ($i=1; $i<=12; $i++)
						{
							if ($i<10)
							{
								$currentMonth="month0$i";
							}
							else
							{
								$currentMonth="month$i";
							}
	       					echo ('<option label="'.$dictionary[$currentMonth].'" value="'.$i.'"');
	       					if ($i==$dateUtils->getMonthFromDate($renderObjects->endDate))
	       					{
	       						echo (' selected="selected"');
	       					}
	       					echo ('>'.$dictionary[$currentMonth].'</option>');
	       				}
       				?>
       				</select>
       				<!--
       					Day dropdown box
       				-->
       				<select name="DueDate_Day">
					<?php
						for ($i=1; $i<=31; $i++)
						{
							if ($i<10)
							{
								$currentDay = '0'.$i;
							}
							else
							{
								$currentDay = $i;
							}
							echo ('<option label="'.$currentDay.'" value="'.$currentDay.'"');
							if ($i == $dateUtils->getDayInMonthFromDate($renderObjects->endDate))
							{
	       						echo (' selected="selected"');
							}
							echo ('>'.$currentDay.'</option>');
						}
					?>
					</select>
       				<!--
       					Year dropdown box
       				-->
       				<select name="DueDate_Year">
       				<?php
						$currentYear = $dateUtils->getYearFromDate ($renderObjects->endDate);

						for ($i=5; $i>10; $i--)
						{
							echo ('<option label="'.($currentYear-$i).'" value="'.($currentYear-$i).'"');
							echo ('>'.($currentYear-$i).'</option>');
						}
						echo ('<option label="'.$currentYear.'" value="'.$currentYear.'"');
						echo (' selected="selected"');
						echo ('>'.$currentYear.'</option>');
						for ($i=1; $i<=10; $i++)
						{
							echo ('<option label="'.($currentYear+$i).'" value="'.($currentYear+$i).'"');
							echo ('>'.($currentYear+$i).'</option>');
						}
       				?>
       				</select>
				<!--
					<php echo html_select_date
					end_year="+10"
					prefix="DueDate_"
					time=$renderObjects->endDate >
					-->
				</td>
			</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td colspan="2">
			<?php echo $dictionary['description'] ?>: <textarea name="description"
				cols="80" rows="10"
				><?php echo $stringUtils->urlEncodeQuotes ($renderObjects->description) ?></textarea>
		</td>
	</tr>
	</table>
	<h2><?php echo $dictionary['modify'] ?> <?php echo $dictionary['todo'] ?></h2>
	<input type="hidden" value="modifyTodo" name="action" />
	<input type="hidden" value=<?php echo $renderObjects->itemId ?> name="itemId" />
		<!--
	<input type="hidden" value=<?php echo $renderObjects->parentId ?> name="parentId" />
		-->
	<input type="submit" value="<?php echo $dictionary['modify'] ?>" name="modifyTodo" />
</form>

<h2><?php echo $dictionary['move'] ?> <?php echo $dictionary['todo'] ?></h2>
<form method="POST" action="TodoController.php">
	<input type="hidden" value="move" name="action" />
	<input type="hidden" value=<?php echo $renderObjects->itemId ?> name="itemId" />
	<input type="submit" value="<?php echo $dictionary['move'] ?>" name="moveItem" />
</form>

<h2><?php echo $dictionary['delete'] ?> <?php echo $dictionary['todo'] ?></h2>
<form method="POST" action="TodoController.php"
        onsubmit="return confirmDelete()"
>
	<input type="hidden" value="delete" name="action" />
	<input type="hidden" value=<?php echo $renderObjects->itemId ?> name="itemId" />
	<input type="submit" value="<?php echo $dictionary['delete'] ?>" name="deleteTodo" />
		<!--
	<input type="hidden" value=<?php echo $renderObjects->parentId ?> name="parentId" />
		-->
</form>

