<?php
/**
 * vim: set number :
 * vim: set tabstop=4 : 
 *
 * The template file to show todos
 * 
 * @package be.nauta.booby.plugins.todos.view
 * @author Barry Nauta
 * @copyright Barry Nauta
 * 
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: <code>http://www.gnu.org</code> and look for licenses
 *
 * Enjoy :-)
 */
		// Show the ancestor path. Contributed by Michael
		if(isset($parameters['ancestors']) && $parentId != 0)
		{
			echo ('<!-- Ancestors -->');
			echo ('<table><tr>');
			
			// The root link
			echo ('<td><a href="?parentId=0" class="ancestor">'.
				$dictionary['root'].'</a></td>');
	
			// all ancestors other than root
			foreach($parameters['ancestors'] as $ancestor)
			{ 
				echo ('<td>&nbsp;/&nbsp;');
				echo ('<a href="?parentId='.$ancestor->itemId.
					'" class="ancestor">');
				echo ($ancestor->name);
				echo ('</a>');
				echo ('</td>');
			}
			echo ('</tr></table>');
		}		
	
		include ('templates/'.$_SESSION['booby_template'].'/icons.inc');
		$configuration = array ();

		// Build up a proper configuration for the tree display.
		$configuration['icons']=$icons;
		$configuration['dictionary']=$dictionary;
		$configuration['callback']='TodoController.php';
		
		// Check for optional overlib
		if (isset ($_SESSION['todoOverlib']))
		{
			$configuration ['overlib'] =$_SESSION['todoOverlib'];
		}
		else
		{
			$configuration ['overlib'] = true;
		}
		
		// Yahoo like tree
		if (isset ($_SESSION['todoTree']) 
			&& $_SESSION['todoTree'] == 'Yahoo')
		{
				// Build up a proper configuration for the tree display,
			    // this makes only sense for the yahoo-like tree
				if (isset ($_SESSION['todoYahooTreeColumnCount']))
				{
					$configuration ['numberOfColumns'] =
						$_SESSION['todoYahooTreeColumnCount'];
				}
				else
				{
					$configuration ['numberOfColumns'] = 2;
				}
				include_once "base/view/YahooTree.php";
				include_once "plugins/todos/view/TodoYahooTreeDelegate.php";
				$delegate = new TodoYahooTreeDelegate ($configuration);
				$tree = new YahooTree ($delegate, $configuration);
		}
		// Explorer like tree
		else if (isset ($_SESSION['todoTree']) 
			&& $_SESSION['todoTree'] == 'Explorer')
		{
				include_once "base/view/Tree.php";
				include_once "plugins/todos/view/TodoExplorerTreeDelegate.php";
				$delegate = new TodoExplorerTreeDelegate ($configuration);
				$tree = new Tree ($delegate, $configuration);

				// Do we show expanded items? 
				// (This is not a useful option in the yahoo tree)
				if (isset ($_SESSION['todoExpand']))
				{
					$tree->setExpanded ($_SESSION['todoExpand']);
				}
		}
		// Overview tree
		else if (isset ($_SESSION['todoTree'])
			&& $_SESSION['todoTree'] == 'Overview')
		{
			include_once "base/view/OverviewTree.php";
			include_once "plugins/todos/view/TodoOverviewTreeDelegate.php";
			$delegate = new TodoOverviewTreeDelegate ($configuration);
			$tree = new OverviewTree ($delegate, $configuration);
			if (isset ($_SESSION['todoExpand']))
			{
				$tree->setExpanded ($_SESSION['todoExpand']);
			}
		}
		// Linebased tree
		//else if (isset ($_SESSION['todoTree']) 
			//&& $_SESSION['todoTree'] == 'LineBased')
		else
		{
			include_once "base/view/LineBasedTree.php";
			include_once "plugins/todos/view/TodoLineBasedTreeDelegate.php";

			$delegate = new TodoLineBasedTreeDelegate ($configuration);
			$tree = new LineBasedTree ($delegate, $configuration);
		}
		// Now actually show the layout
		echo ($tree -> toHtml ($parent, $renderObjects));
?>
