<?php
/*
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 */
require_once ('base/Controller.php');
require_once ('base/util/StringUtils.php');
require_class ('RightsManagerImpl', 'plugins/bookmarks/RightsManagerImpl.php'); // added by Michael
require_class ('RequestCast', 'base/util/request/RequestCast.class.php'); // added by Michael
/**
 * The Webtools Controller
 *
 * @package be.nauta.booby.plugins.webtools
 * @author Barry Nauta March 2004
 * @copyright
 *
 * Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes on the following
 * website: <code>http://www.gnu.org</code>
 * and look for licenses
 */
class WebtoolsController extends Controller
{
	var $stringUtils;

	/**
	 * Constructor. 
	 * Makes sure that the appropriate operations are instantiated.
	 */
	function WebtoolsController ()
	{
		parent::Controller ();
		
		$this->rightsManager = new RightsManagerImpl(); 

		$this->pluginName = 'webtools';
		$this->title = 'Booby - Webtools';
		$this->itemName = 'Webtools';
		$this->stringUtils = new StringUtils ();
	}

	 
	/**
 	 * Returns the actions defined for this item only
 	 *
 	 * @return array an array of item specific actions (like search, import etc.)
 	 */
	function getActions ()
	{
		$dictionary = $this->getDictionary ();
	
		/*
		 * Views
		 */
		$actions[1]['name'] = $dictionary['view'];
		//if($this->rightsManager->isGranted($this->getParentId (), "view"))
		//{
			$actions[1]['contents'][] = array
				(
					'href'=>'WebtoolsController.php?action=namedColors',
					'name'=>'Named Colors'
				);
			$actions[1]['contents'][] = array
				(
					'href'=>'WebtoolsController.php?action=rot13',
					'name'=>'rot13'
				);
			$actions[1]['contents'][] = array
				(
					'href'=>'WebtoolsController.php?action=colorWheel',
					'name'=>'ColorWheel'
				);
			$actions[1]['contents'][] = array
				(
					'href'=>'WebtoolsController.php?action=htmlEscapeCodes',
					'name'=>$dictionary['htmlEscapeCodes']
				);

			if ($this->getUserName () == 'admin')
			{
				$actions[1]['contents'][] = array
				(
					'href'=>'WebtoolsController.php?action=shell',
					'name'=>$dictionary['shell']
				);
			}
			$actions[1]['contents'][] = array
				(
					'href'=>'WebtoolsController.php?action=asciiTable',
					'name'=>$dictionary['ascii_table']
				);
// There are more extended ascii versions.
//			$actions[1]['contents'][] = array
//				(
//					'href'=>'WebtoolsController.php?action=extendedAsciiTable',
//					'name'=>$dictionary['extended_ascii_table']
//				);
			$actions[1]['contents'][] = array
				(
					'href'=>'WebtoolsController.php?action=colorCodes',
					'name'=>$dictionary['color_codes']
				);
		//}

		/*
		 * Preferences
		 */		
		 /*
		if($this->rightsManager->isGranted($this->getParentId (), "preferences"))
		{
			$actions[3]['name'] = $dictionary['preferences'];
			$actions[3]['contents'][] = array('href'=> 'WebtoolsController.php?action=modifyPreferencesPre',
			'name' => $dictionary['modify']);
		}
	*/	
		return $actions;
	}

	/**
	 * Activate. Basically this means that the appropriate actions are executed and an optional result is returned
	 * to be processed/displayed
	 */
	function activate ()
	{
		switch ($this->getAction ())
		{
			// Modified by Michael. I wonder if this "directAction" I added is not nonsens... 
			case "rot13":
				$this->renderer = 'rot13';
				if (isset ($_POST['inputString']))
				{
					$theString = 
						$this->stringUtils->gpcStripSlashes ($_POST['inputString']);
					$this->renderEngine->assign (
						'inputString', $theString);
					$this->renderEngine->assign (
						'rotatedInput',
						$this->rotate13($theString));
				}
				break;
			case "shell":
				$output = null;
				$command = null;
				if (isset ($_POST['command']))
				{
					$command = $_POST['command'];
					$command .= ' 2>&1';
					$this->addParameter ('command', $_POST['command']);
					exec ($command, $output);
					$this->addParameter ('output', $output);
				}
				else
				{
					$this->addParameter ('command', 'ls');
					exec ('ls', $output);
					$this->addParameter ('output', $output);
				}
				$this->renderer = 'cli';
				break;
			case "namedColors":
				$this->renderer = 'namedColors';
				break;
			case "colorWheel":
				$this->renderer = 'colorWheel';
				break;
			case "htmlEscapeCodes":
				$this->renderer = 'htmlEscapeCodes';
				break;
			case "asciiTable":
				$this->renderer = 'asciiTable';
				break;
			case "extendedAsciiTable":
				$this->renderer = 'extendedAsciiTable';
				break;
			case "colorCodes":
				$this->renderer = 'colorCodes';
				break;
			case "setModePublic":
				$_SESSION['navigationMode']='public';
				$this->navigationMode ='public';
				//$this->getShowItemsParameters ();
				break;
			case "setModePrivate":
				$_SESSION['navigationMode']='private';
				$this->navigationMode ='private';
				//$this->getShowItemsParameters ();
				break;
			case "modifyPreferencesPre":
				$this->renderObjects = 
					$this->preferences->getAllPreferences ($this->getUserName ());
				$this->renderer = 'modifyPreferences';
				break;
			case "modifyPreferencesPost":
				$this->preferences->setPreference ($this->getUserName (), $_POST['name'], $_POST['value']);
				//$this->getShowItemsParameters ();
				break;
			default:
				//$this->getShowItemsParameters ();
				break;
		}
	}

	/**
	 * Display which basically means that the template will be invoked
	 */
	function displayObsolete ()
	{
		global $menuItems, $menu;

		$this->renderEngine->assign('title', $this->getTitle ());
		$this->renderEngine->assign('menuItems', $menuItems);
		$this->renderEngine->assign('menu', $menu);
		$this->renderEngine->assign('dictionary', $this->getDictionary ());

		$this->renderEngine->assign('parameters', 
			$this->getParameters ());
		$this->renderEngine->assign('action', 
			$this->getAction ());
		$this->renderEngine->assign('renderActions', 
			$this->getActions ());
			
		$this->renderEngine->assign ('pluginName', $this->pluginName);
		$this->renderEngine->assign ('renderer', $this->getTemplateFile ());
		if (isset ($_GET['debug']))
		{
			error_reporting(E_ALL);			
			$this->renderEngine->display('templates/'.$this->getTemplate().'/template.tpl.php');
			// todo add more
		}
		else
		{
			error_reporting(E_ERROR);
			@$this->renderEngine->display('templates/'.$this->getTemplate().'/template.tpl.php');
		}
	}


	function rotate13 ($input)
	{
		if (!function_exists('str_rot13')) 
		{
		   //function str_rot13($str) {
		  $from = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
		  $to  = 'nopqrstuvwxyzabcdefghijklmNOPQRSTUVWXYZABCDEFGHIJKLM';

		return strtr($str, $from, $to);
							   //}
		}
		else
		{
			return str_rot13 ($input);
		}
	}

}
//$controller = new WebtoolsController ();
//$controller -> activate ();
//$controller -> display ();
?>
