<?php
/**
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 Barry Nauta
 *
 * The Booby project is released under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 * @package be.nauta.booby.login
 * @author Barry Nauta 
 * @copyright Barry Nauta	
 */
require_once ('base/util/databaseConnection.php');
include_once ('base/sql/authQueries.php');
require_once ('base/model/User.php');
require_once ('base/model/UserFactory.php');
require_once ('base/model/Preference.php');
require_once ('base/model/UserServices.php');
require_once ('base/model/PreferenceServices.php');
require_once ('base/model/AdminServices.php');

$defaultLanguage = 'EN';
$defaultTemplate = 'mylook';

$userFactory = new UserFactory ();
$adminServices = new AdminServices ();
$allowSignon = $adminServices->getAdminConfig ('allow_account_creation');
if (!allowSignon)
{
	/*
	 * We can only request this is allowed by admin
	 */ 
	if(!$_POST['loginName'] | !$_POST['password'])
	{
		$message='illegalAccess';
		Header ("Location: login.php?message=".$message);
		exit;
	}
}
if (isset($_POST['submit']))
{
	/*
	 * Check for username and password on POST. If this is not set, there was an 
	 * attempt -> illegal access?
	 */
	if(!$_POST['loginName'] | !$_POST['password'])
	{
		$message='illegalAccess';
		Header ("Location: login.php?message=".$message);
		exit;
	}

	/*
	 * Check whether the two provided passwords match
	 */
	if ($_POST['password'] != $_POST['password2'])
	{
		$message = 'passwordMismatch';
		Header ("Location: login.php?message=".$message);
		exit;
	} 
	
	/*
	 * Query the database to see whether the requested id for the user
	 * does not already exist in the database
	 */
	$query = sprintf ($queries ['getUsernamePassword'], $_POST['loginName']);
	$result = $db->Execute($query) or die ($db->ErrorMsg ());

	$dbUsername = $result->fields[0];

	/*
	 * Check whether we have received a username from the database. If this
	 * is the case, the username already exists and cannot be added
	 */
	if ($dbUsername != null || $dbUsername != "")
	{
		$message='userAlreadyExists';
		Header ("Location: login.php?message=".$message);
		exit;
	}
	$adminEmail = $adminServices->getAdminConfig ('admin_email');
	/*
	 * Now physically add the user and its preferences.
	 * We can now also savely set the username on the session so the user
	 * is directly logged in.
	 */ 
	$userSettings = $userFactory->requestToUser ();
	$preferencesServices = new PreferenceServices ();
	$userServices = new UserServices ();
	
	session_start();
	$_SESSION['boobyUsername'] = $userSettings->loginName;
	$languagePreference = new Preference (null, $_SESSION['boobyUsername'], 0, 0, 'language', 
					null, 'private', null, null, null, $defaultLanguage);
	$templatePreference = new Preference (null, $_SESSION['boobyUsername'], 0, 0, 'booby_template', 
					null, 'private', null, null, null, $defaultTemplate);
					//die (print_r ($languagePreference));
	$preferencesServices->addItem ($_SESSION['boobyUsername'], $languagePreference);
	$preferencesServices->addItem ($_SESSION['boobyUsername'], $templatePreference);
	
	$userServices->addUser ($_SESSION['boobyUsername'], $userSettings);

	/*
	 * Ok, username does not exist and credentials (passwords) appear to be valid.
	 * Send a mail to the site admin
	 */
	$message = "A new user (".$_POST['loginName'].") just signed in";
	$message .= "
		Address: ".$_SERVER['REMOTE_ADDR'];

	$subject = "New user (".$_POST['loginName'].") addition";

	$headers = "MIME-Version: 1.0\r\n";
	$headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
	$headers .= "From: Booby administrator <".$adminEmail.">\r\n";
	$headers .= "To: Booby administrator <".$adminEmail.">\r\n";
	$headers .= "X-Mailer: Booby";

	mail($adminEmail, $subject, $message, $headers);
	/*
	 * Forward to the login page with an appropriate message
	 */
	Header ("Location: index.php");
	exit;
}

?>
