<?php
/**
 * vim: set number :
 * vim: set tabstop=4 :
 *
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is release under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 *
 * @package be.nauta.booby.templates.mylook
 * @author Barry Nauta
 * @copyright Barry Nauta
 */
 ?>
<html>
<head>
	<title><?php echo $item_title ?></title>
	<link rel="stylesheet" type="text/css" 
		href="templates/mylook/template.css" />
	<meta http-equiv="Content-Type" 
		content="text/html; charset=<?php echo $dictionary['charset'] ?>">		
		
		
<?php	
	include 'templates/mylook/icons.inc';
	include ('templates/mylook/javascript.inc');
?>
</head>
<body>
	<table border="2" cellspacing="0" cellpadding="5"
		height="95%">
	<tr>
		<!--
			 Menu Bar. Contains links to preferences, about, logout etc.
		-->
		<td colspan="2" class="menu2">
			<!--
				The menubar is a table itself, containing only one row (tr)
				and a datacell (td) for each item
			-->
			<table width="100%" cellpadding="0" cellspacing="0">
			<tr>
				<td>
					<font color="white" color="+1">	
					<?php
						foreach ($menu as $crumb)
						{
					?>
						<a href="<?php echo $crumb['href'] ?>"
							class="menu"
							>[<?php echo $crumb['name'] ?>]</a>
					<?php
						}
					?>
					</font>
				</td>
				<td align="right">
					<h2>Booby</h2>
				</td>
			</tr>
			</table>
		</td>
	</tr>
	<tr>
		<!--
			Contains the menuitems: the links to bookmarks, notes etc.
		-->
		<td width="200" valign="top" class="menu">
			<table witdh="195" valign="top" border="0">
			<!--
				Display the icons for the different plugins
			-->
			<?php
					foreach ($menuItems as $menuItem)
					{
			?>
						<tr>
							<td align="center" valign="top">
								<a href="<?php echo $menuItem['href'] ?>"
								><?php
									require_once ('base/util/BrowserUtils.php');
									$browserUtils = new BrowserUtils ();
									if ($browserUtils->browserIsExplorer())
									{
										$ext = '.jpg';
									}
									else
									{
										$ext = '.png';
									}
									/*
									 * First check whether the plugin has a template subdirectory for this specific
									 * template and if it does, fetch the icon from there
									 */
									if (isset ($menuItem['icon']) &&
										file_exists ('plugins/'.$menuItem['icon'].'/view/pics/'.$_SESSION['booby_template'].'/item'.$ext))
									{
										echo ('<img src="plugins/'.$menuItem['icon'].'/view/pics/'.$_SESSION['booby_template'].'/item'.$ext.'" border="0">');
									}
									/*
									 * Else try to load the template icon. 
									 */								 
									else if (isset ($menuItem['icon']) && isset ($icons[$menuItem['icon']]))
									{
										echo $icons[$menuItem['icon']];
									} 
									/*
									 * Else load the default icon for this plugin
									 */
									else 
									{
										echo ('<img src="plugins/'.$menuItem['icon'].'/view/pics/default/item'.$ext.'" border="0">');
									}
								?></a>
						<br />
						<!--
							Print the name of the plugin under the icon
						-->
						<?php echo $menuItem['name'] ?>
					</td>
				</tr>
			<?php
				}
			?>
			<tr>
				<td valign="bottom">
					<!--
						Display the booby image under all menuitems
					-->
					<a href="index.php"><img 
						src="templates/mylook/pics/blue_booby.gif" 
						border="0"/></a>
				</td>
			</tr>
			</table>
		</td>
		<!--
			Display the actual content pane. This content pane should be of no real
			concern for the template.
		-->
		<td width="100%" valign="top" bgcolor="#ffffff">
			<table width="100%">
				<tr>
					<td valign="top">
						<?php
							include $renderer;
						?>
					</td>
					<td align="right" valign="top">
						<h1><?php echo $dictionary['item_title'] ?></h1>
						<!--
							Now display the actions that can be performed on this item
						-->
						<?php
							if ($renderActions != null)
							{
								foreach ($renderActions as $renderAction)
								{
						?>
								<!--
									Render actions are labeled under a header like
									'actions', 'view' etc
								-->
									<table width="200" border="0" cellpadding="0" 
										cellspacing="0">
					               			<tr valign="top">
					                   			<td align="right">
													<h2><?php echo $renderAction['name'] ?></h2>
												</td>
					               			</tr>
					               			<tr>
												<td align="right">
													<?php
														foreach ($renderAction['contents'] as $current)
														{
													?>
														<a href="<?php echo $current['href'] ?>"
															>[<?php echo $current['name'] ?>]</a>
							
													<?php
														}
													?>
					                   			</td>
										</tr>
									</table>
						<?php
								}
							}
						?>
						<br />
						<?php
							if ($dictionary['item_help']!=null && $dictionary['item_help']!='')
							{
								echo ('<h2>');
								echo ($dictionary['help']);
								echo ('</h2>');
								echo ($dictionary['item_help']);
							}
							if (isset ($message) && $message != null)
							{
								echo ('<h2>');
								echo ($icons['message'].'&nbsp;');
								echo ($dictionary['message']);
								echo ('</h2>');
								echo ($message);
							} 
						 ?>
					</td>
				</tr>
			</table>					
		</td>
	</tr>
	<!--
		License disclaimer at the bottom
	-->
	<tr>
		<td colspan="2">
    		<p>
        		<font size="-2">
					<?php echo $dictionary['license_disclaimer'] ?>
        		</font> 
    		</p>    
		</td>
	</tr>
	</table>
	<?php /* print_r ($this); */ ?>
</body>
</html>
