<?php
/**
 * vim: set tabstop=4 :
 *
 * This file is part of the Booby project.
 * The booby project is located at the following location:
 * http://www.nauta.be/booby/
 *
 * Booby - Copyright (c) 2003 - 2004 Barry Nauta
 *
 * The Booby project is release under the General Public License
 * More detailes in the file 'gpl.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 * Enjoy :-)
 *
 * @package be.nauta.booby.templates.penguin
 * @author Barry Nauta
 * @copyright Barry Nauta
 */
 ?>
<html>
<head>
	<title><?php echo $item_title ?></title>
	<link rel="stylesheet" type="text/css" 
		href="templates/penguin/template.css" />
	<meta http-equiv="Content-Type" 
		content="text/html; charset=<?php echo $dictionary['charset'] ?>">		
	
	<?php 
		if (file_exists ('plugins/'.$pluginName.'/view/pics/'.$_SESSION['booby_template'].'/favicon.ico'))
		{
			echo ('<link rel="Shortcut Icon" type="image/x-ico" ');
			echo ('href="plugins/'.$pluginName.'/view/pics/'.$_SESSION['booby_template'].'/favicon.ico" />');
		}
		else if (file_exists ('plugins/'.$pluginName.'/view/pics/default/favicon.ico'))
		{
			echo ('<link rel="Shortcut Icon" type="image/x-ico" ');
			echo ('href="plugins/'.$pluginName.'/view/pics/default/favicon.ico" />');
		}
	?>
	<?php include "templates/penguin/icons.inc" ?>
	<?php include ('templates/penguin/javascript.inc') ?>
</head>
<body bgcolor="#ffffff">
	<table border="0" cellspacing="5" cellpadding="0"
		height="95%">
	<tr>
		<!--
			 Menu Bar. Contains links to preferences, about, logout etc.
		-->
		<td colspan="2" class="menu2">
			<!--
				The menubar is a table itself, containing only one row (tr)
				and a datacell (td) for each item
			-->
			<table width="100%" cellpadding="0" cellspacing="0">
			<tr>
				<td>
					<font color="white" color="+1">	
					<table>
					<tr>

						<?php 
							foreach ($menu as $crumbs) 
							{
						?>
							<td align="center">
								<a href="<?php echo ($crumbs['href']) ?>"
										class="menu"
										>[<?php echo ($crumbs['name']) ?>]</a>
							</td>
						<?php
							}
						?>
					</tr>
					</table>
				</td>
			</tr>
			</table>
			</font>
		</td>
	</tr>
	<tr>
		<!--
			Display the actual content pane. 
			This content pane should be of no real concern for the template.
		-->
		<td width="100%" valign="top">
			<table cellpadding="5" cellspacing="5" bgcolor="#f3f3f3"
				width="100%" height="100%">
			<tr>
				<td valign="top" width="100%">
						<?php include $renderer ?>
				</td>
				<td align="right" valign="top">
					<h1><?php echo $dictionary['item_title'] ?></h1>
					<!--
						Now display the actions that can be performed on 
						this item
					-->
					<?php
						if ($renderActions != null)
						{
							foreach ($renderActions as $renderAction)
							{
					?>
							<!--
								Render actions are labeled under a header like
									'actions', 'view' etc
							-->
								<table width="200" border="0" cellpadding="0" 
										cellspacing="0">
					       			<tr valign="top">
					          			<td align="right">
											<h2><?php echo $renderAction['name'] ?></h2>
										</td>
					           		</tr>
					           		<tr>
										<td align="right">
											<?php
												foreach ($renderAction['contents'] as $current)
												{
											?>
													<a href="<?php echo $current['href'] ?>"
														>[<?php echo $current['name'] ?>]</a>
							
											<?php
												}
											?>
					           			</td>
									</tr>
								</table>
						<?php
								}
							}
						?>
						<br />
						<?php
							if ($dictionary['item_help']!=null && $dictionary['item_help']!='')
							{
								echo ('<h2>');
								echo ($dictionary['help']);
								echo ('</h2>');
								echo ($dictionary['item_help']);
							}
							if (isset ($message) && $message != null)
							{
								echo ('<h2>');
								echo ($icons['message'].'&nbsp;');
								echo ($dictionary['message']);
								echo ('</h2>');
								echo ($message);
							} 
						 ?>
					</td>
				
			</tr>
			</table>
		</td>
		<!--
			The menu bar containing first the text-logo (Booby), 
			afterwards the different icons for the different booby plugins
			like bookmarks, notes etc and afterwards the penguin logo
		-->
		<td width="200" valign="top" class="menu" bgcolor="#ffffff">
			<table witdh="195" valign="top" border="0">
			<tr>
				<!--
					Display the text-logo (Booby)
				-->
				<td align="right">
					<img src="templates/<?php echo 
						$_SESSION['booby_template'] ?>/pics/booby_logo.jpg">
				</td>
			</tr>
			<!--
				Display the icons for the different plugins
			-->
			<?php
				foreach ($menuItems as $menuItem)
				{
			?>
					<tr>
						<td align="center" valign="top">
							<a href="<?php echo $menuItem['href'] ?>"
							><?php
								require_once ('base/util/BrowserUtils.php');
								$browserUtils = new BrowserUtils ();
								if ($browserUtils->browserIsExplorer())
								{
									$ext = '.jpg';
								}
								else
								{
									$ext = '.png';
								}
								/*
								 * First check whether the plugin has a 
								 * template subdirectory for this specific
								 * template and if it does, fetch the icon 
								 * from there
								 */
								if (isset ($menuItem['icon']) &&
										file_exists ('plugins/'.$menuItem['icon'].'/view/pics/'.$_SESSION['booby_template'].'/item'.$ext))
								{
									echo ('<img src="plugins/'.$menuItem['icon'].'/view/pics/'.$_SESSION['booby_template'].'/item'.$ext.'" border="0">');
								}
								/*
								 * Else try to load the template icon. 
								 */								 
								else if (isset ($menuItem['icon']) && isset ($icons[$menuItem['icon']]))
								{
									echo $icons[$menuItem['icon']];
								} 
								/*
								 * Else load the default icon for this plugin
								 */
								else 
								{
									echo ('<img src="plugins/'.$menuItem['icon'].'/view/pics/default/item'.$ext.'" border="0">');
								}
							?></a>
						<br />
						<!--
							Print the name of the plugin under the icon
						-->
						<?php echo $menuItem['name'] ?>
					</td>
				</tr>
			<?php
				}
			?>
			<!--
				Display the penguin logo
			--> 
			<tr>
				<td valign="bottom">
					<a href="index.php"><img 
						src="templates/penguin/pics/linux.jpg" 
						border="0"/></a>
				</td>
			</tr>
			</table>
		</td>
	</tr>
	<!--
		Display the license disclaimer
	-->
	<tr>
		<td colspan="2">
    		<p>
        		<font size="-2">
					<?php echo $dictionary['license_disclaimer'] ?>
        		</font> 
    		</p>    
		</td>
	</tr>
	</table>
</body>
</html>
